/* ComponentWatcher.c generated by valac 0.43.6, the Vala compiler
 * generated from ComponentWatcher.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*- */
/*
 * Copyright (C) 2018 elementary LLC. <https://elementary.io>
 *
 * Cerbere is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Cerbere is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cerbere; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 * Authors: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <sys/wait.h>

#define GREETER_TYPE_COMPONENT_WATCHER (greeter_component_watcher_get_type ())
#define GREETER_COMPONENT_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_COMPONENT_WATCHER, GreeterComponentWatcher))
#define GREETER_COMPONENT_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_COMPONENT_WATCHER, GreeterComponentWatcherClass))
#define GREETER_IS_COMPONENT_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_COMPONENT_WATCHER))
#define GREETER_IS_COMPONENT_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_COMPONENT_WATCHER))
#define GREETER_COMPONENT_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_COMPONENT_WATCHER, GreeterComponentWatcherClass))

typedef struct _GreeterComponentWatcher GreeterComponentWatcher;
typedef struct _GreeterComponentWatcherClass GreeterComponentWatcherClass;
typedef struct _GreeterComponentWatcherPrivate GreeterComponentWatcherPrivate;
typedef enum  {
	GREETER_COMPONENT_WATCHER_STATUS_INACTIVE,
	GREETER_COMPONENT_WATCHER_STATUS_STARTING,
	GREETER_COMPONENT_WATCHER_STATUS_RUNNING,
	GREETER_COMPONENT_WATCHER_STATUS_TERMINATED
} GreeterComponentWatcherStatus;

#define GREETER_COMPONENT_WATCHER_TYPE_STATUS (greeter_component_watcher_status_get_type ())
enum  {
	GREETER_COMPONENT_WATCHER_0_PROPERTY,
	GREETER_COMPONENT_WATCHER_NUM_PROPERTIES
};
static GParamSpec* greeter_component_watcher_properties[GREETER_COMPONENT_WATCHER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _GreeterComponentWatcher {
	GObject parent_instance;
	GreeterComponentWatcherPrivate * priv;
};

struct _GreeterComponentWatcherClass {
	GObjectClass parent_class;
};

struct _GreeterComponentWatcherPrivate {
	guint crash_count;
	gchar* command;
	GreeterComponentWatcherStatus status;
	GPid pid;
	GTimer* timer;
};

static gint GreeterComponentWatcher_private_offset;
static gpointer greeter_component_watcher_parent_class = NULL;

GType greeter_component_watcher_get_type (void) G_GNUC_CONST;
GType greeter_component_watcher_status_get_type (void) G_GNUC_CONST;
#define GREETER_COMPONENT_WATCHER_CRASH_TIME_INTERVAL 3.5
#define GREETER_COMPONENT_WATCHER_MAX_CRASHES ((guint) 5)
GreeterComponentWatcher* greeter_component_watcher_new (const gchar* command);
GreeterComponentWatcher* greeter_component_watcher_construct (GType object_type,
                                                              const gchar* command);
void greeter_component_watcher_run (GreeterComponentWatcher* self);
void greeter_component_watcher_reset_crash_count (GreeterComponentWatcher* self);
static void __lambda4_ (GreeterComponentWatcher* self,
                 GAppInfo* info,
                 GVariant* platform_data);
static void greeter_component_watcher_on_process_watch_exit (GreeterComponentWatcher* self,
                                                      GPid pid,
                                                      gint status);
static void _greeter_component_watcher_on_process_watch_exit_gchild_watch_func (GPid pid,
                                                                         gint status,
                                                                         gpointer self);
static void ___lambda4__g_app_launch_context_launched (GAppLaunchContext* _sender,
                                                GAppInfo* info,
                                                GVariant* platform_data,
                                                gpointer self);
static void __lambda5_ (GreeterComponentWatcher* self);
static void ___lambda5__g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                     const gchar* startup_notify_id,
                                                     gpointer self);
void greeter_component_watcher_terminate (GreeterComponentWatcher* self,
                                          gboolean restart);
static void greeter_component_watcher_finalize (GObject * obj);

static inline gpointer
greeter_component_watcher_get_instance_private (GreeterComponentWatcher* self)
{
	return G_STRUCT_MEMBER_P (self, GreeterComponentWatcher_private_offset);
}

GType
greeter_component_watcher_status_get_type (void)
{
	static volatile gsize greeter_component_watcher_status_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_component_watcher_status_type_id__volatile)) {
		static const GEnumValue values[] = {{GREETER_COMPONENT_WATCHER_STATUS_INACTIVE, "GREETER_COMPONENT_WATCHER_STATUS_INACTIVE", "inactive"}, {GREETER_COMPONENT_WATCHER_STATUS_STARTING, "GREETER_COMPONENT_WATCHER_STATUS_STARTING", "starting"}, {GREETER_COMPONENT_WATCHER_STATUS_RUNNING, "GREETER_COMPONENT_WATCHER_STATUS_RUNNING", "running"}, {GREETER_COMPONENT_WATCHER_STATUS_TERMINATED, "GREETER_COMPONENT_WATCHER_STATUS_TERMINATED", "terminated"}, {0, NULL, NULL}};
		GType greeter_component_watcher_status_type_id;
		greeter_component_watcher_status_type_id = g_enum_register_static ("GreeterComponentWatcherStatus", values);
		g_once_init_leave (&greeter_component_watcher_status_type_id__volatile, greeter_component_watcher_status_type_id);
	}
	return greeter_component_watcher_status_type_id__volatile;
}

GreeterComponentWatcher*
greeter_component_watcher_construct (GType object_type,
                                     const gchar* command)
{
	GreeterComponentWatcher * self = NULL;
	gchar* _tmp0_;
#line 40 "../src/ComponentWatcher.vala"
	g_return_val_if_fail (command != NULL, NULL);
#line 40 "../src/ComponentWatcher.vala"
	self = (GreeterComponentWatcher*) g_object_new (object_type, NULL);
#line 41 "../src/ComponentWatcher.vala"
	_tmp0_ = g_strdup (command);
#line 41 "../src/ComponentWatcher.vala"
	_g_free0 (self->priv->command);
#line 41 "../src/ComponentWatcher.vala"
	self->priv->command = _tmp0_;
#line 42 "../src/ComponentWatcher.vala"
	greeter_component_watcher_run (self);
#line 40 "../src/ComponentWatcher.vala"
	return self;
#line 154 "ComponentWatcher.c"
}

GreeterComponentWatcher*
greeter_component_watcher_new (const gchar* command)
{
#line 40 "../src/ComponentWatcher.vala"
	return greeter_component_watcher_construct (GREETER_TYPE_COMPONENT_WATCHER, command);
#line 162 "ComponentWatcher.c"
}

void
greeter_component_watcher_reset_crash_count (GreeterComponentWatcher* self)
{
#line 45 "../src/ComponentWatcher.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/ComponentWatcher.vala"
	self->priv->crash_count = (guint) 0;
#line 172 "ComponentWatcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../src/ComponentWatcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 180 "ComponentWatcher.c"
}

static void
_greeter_component_watcher_on_process_watch_exit_gchild_watch_func (GPid pid,
                                                                    gint status,
                                                                    gpointer self)
{
#line 67 "../src/ComponentWatcher.vala"
	greeter_component_watcher_on_process_watch_exit ((GreeterComponentWatcher*) self, pid, status);
#line 190 "ComponentWatcher.c"
}

static void
__lambda4_ (GreeterComponentWatcher* self,
            GAppInfo* info,
            GVariant* platform_data)
{
	GTimer* _tmp0_;
	GPid _tmp1_ = 0;
#line 60 "../src/ComponentWatcher.vala"
	g_return_if_fail (info != NULL);
#line 60 "../src/ComponentWatcher.vala"
	g_return_if_fail (platform_data != NULL);
#line 62 "../src/ComponentWatcher.vala"
	_tmp0_ = g_timer_new ();
#line 62 "../src/ComponentWatcher.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 62 "../src/ComponentWatcher.vala"
	self->priv->timer = _tmp0_;
#line 63 "../src/ComponentWatcher.vala"
	g_variant_lookup (platform_data, "pid", "i", &_tmp1_, NULL);
#line 63 "../src/ComponentWatcher.vala"
	self->priv->pid = _tmp1_;
#line 64 "../src/ComponentWatcher.vala"
	self->priv->status = GREETER_COMPONENT_WATCHER_STATUS_RUNNING;
#line 67 "../src/ComponentWatcher.vala"
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, self->priv->pid, _greeter_component_watcher_on_process_watch_exit_gchild_watch_func, g_object_ref (self), g_object_unref);
#line 218 "ComponentWatcher.c"
}

static void
___lambda4__g_app_launch_context_launched (GAppLaunchContext* _sender,
                                           GAppInfo* info,
                                           GVariant* platform_data,
                                           gpointer self)
{
#line 60 "../src/ComponentWatcher.vala"
	__lambda4_ ((GreeterComponentWatcher*) self, info, platform_data);
#line 229 "ComponentWatcher.c"
}

static void
__lambda5_ (GreeterComponentWatcher* self)
{
#line 71 "../src/ComponentWatcher.vala"
	self->priv->status = GREETER_COMPONENT_WATCHER_STATUS_TERMINATED;
#line 237 "ComponentWatcher.c"
}

static void
___lambda5__g_app_launch_context_launch_failed (GAppLaunchContext* _sender,
                                                const gchar* startup_notify_id,
                                                gpointer self)
{
#line 70 "../src/ComponentWatcher.vala"
	__lambda5_ ((GreeterComponentWatcher*) self);
#line 247 "ComponentWatcher.c"
}

void
greeter_component_watcher_run (GreeterComponentWatcher* self)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GreeterComponentWatcherStatus _tmp2_;
	GdkDisplay* default_display = NULL;
	GdkDisplay* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkAppLaunchContext* launch_context = NULL;
	GdkDisplay* _tmp7_;
	GdkAppLaunchContext* _tmp8_;
	GdkAppLaunchContext* _tmp9_;
	GdkAppLaunchContext* _tmp10_;
	GError * _inner_error_ = NULL;
#line 49 "../src/ComponentWatcher.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/ComponentWatcher.vala"
	_tmp0_ = self->priv->command;
#line 50 "../src/ComponentWatcher.vala"
	g_debug ("ComponentWatcher.vala:50: STARTING process: %s", _tmp0_);
#line 52 "../src/ComponentWatcher.vala"
	_tmp2_ = self->priv->status;
#line 52 "../src/ComponentWatcher.vala"
	if (_tmp2_ == GREETER_COMPONENT_WATCHER_STATUS_RUNNING) {
#line 52 "../src/ComponentWatcher.vala"
		_tmp1_ = TRUE;
#line 277 "ComponentWatcher.c"
	} else {
		GreeterComponentWatcherStatus _tmp3_;
#line 52 "../src/ComponentWatcher.vala"
		_tmp3_ = self->priv->status;
#line 52 "../src/ComponentWatcher.vala"
		_tmp1_ = _tmp3_ == GREETER_COMPONENT_WATCHER_STATUS_STARTING;
#line 284 "ComponentWatcher.c"
	}
#line 52 "../src/ComponentWatcher.vala"
	if (_tmp1_) {
#line 288 "ComponentWatcher.c"
		const gchar* _tmp4_;
#line 53 "../src/ComponentWatcher.vala"
		_tmp4_ = self->priv->command;
#line 53 "../src/ComponentWatcher.vala"
		g_warning ("ComponentWatcher.vala:53: Process %s is already running. Not starting " \
"it again...", _tmp4_);
#line 54 "../src/ComponentWatcher.vala"
		return;
#line 296 "ComponentWatcher.c"
	}
#line 57 "../src/ComponentWatcher.vala"
	_tmp5_ = gdk_display_get_default ();
#line 57 "../src/ComponentWatcher.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 57 "../src/ComponentWatcher.vala"
	default_display = _tmp6_;
#line 58 "../src/ComponentWatcher.vala"
	_tmp7_ = default_display;
#line 58 "../src/ComponentWatcher.vala"
	_tmp8_ = gdk_display_get_app_launch_context (_tmp7_);
#line 58 "../src/ComponentWatcher.vala"
	launch_context = _tmp8_;
#line 60 "../src/ComponentWatcher.vala"
	_tmp9_ = launch_context;
#line 60 "../src/ComponentWatcher.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp9_, "launched", (GCallback) ___lambda4__g_app_launch_context_launched, self, 0);
#line 70 "../src/ComponentWatcher.vala"
	_tmp10_ = launch_context;
#line 70 "../src/ComponentWatcher.vala"
	g_signal_connect_object ((GAppLaunchContext*) _tmp10_, "launch-failed", (GCallback) ___lambda5__g_app_launch_context_launch_failed, self, 0);
#line 318 "ComponentWatcher.c"
	{
		GAppInfo* appinfo = NULL;
		const gchar* _tmp11_;
		GAppInfo* _tmp12_;
		GAppInfo* _tmp13_;
		GdkAppLaunchContext* _tmp14_;
#line 75 "../src/ComponentWatcher.vala"
		_tmp11_ = self->priv->command;
#line 75 "../src/ComponentWatcher.vala"
		_tmp12_ = g_app_info_create_from_commandline (_tmp11_, NULL, G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 75 "../src/ComponentWatcher.vala"
		appinfo = _tmp12_;
#line 75 "../src/ComponentWatcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 333 "ComponentWatcher.c"
			goto __catch0_g_error;
		}
#line 76 "../src/ComponentWatcher.vala"
		_tmp13_ = appinfo;
#line 76 "../src/ComponentWatcher.vala"
		_tmp14_ = launch_context;
#line 76 "../src/ComponentWatcher.vala"
		g_app_info_launch (_tmp13_, NULL, (GAppLaunchContext*) _tmp14_, &_inner_error_);
#line 76 "../src/ComponentWatcher.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 76 "../src/ComponentWatcher.vala"
			_g_object_unref0 (appinfo);
#line 346 "ComponentWatcher.c"
			goto __catch0_g_error;
		}
#line 77 "../src/ComponentWatcher.vala"
		self->priv->status = GREETER_COMPONENT_WATCHER_STATUS_STARTING;
#line 74 "../src/ComponentWatcher.vala"
		_g_object_unref0 (appinfo);
#line 353 "ComponentWatcher.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 74 "../src/ComponentWatcher.vala"
		e = _inner_error_;
#line 74 "../src/ComponentWatcher.vala"
		_inner_error_ = NULL;
#line 79 "../src/ComponentWatcher.vala"
		_tmp15_ = e;
#line 79 "../src/ComponentWatcher.vala"
		_tmp16_ = _tmp15_->message;
#line 79 "../src/ComponentWatcher.vala"
		g_critical ("ComponentWatcher.vala:79: %s", _tmp16_);
#line 74 "../src/ComponentWatcher.vala"
		_g_error_free0 (e);
#line 373 "ComponentWatcher.c"
	}
	__finally0:
#line 74 "../src/ComponentWatcher.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "../src/ComponentWatcher.vala"
		_g_object_unref0 (launch_context);
#line 74 "../src/ComponentWatcher.vala"
		_g_object_unref0 (default_display);
#line 74 "../src/ComponentWatcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "../src/ComponentWatcher.vala"
		g_clear_error (&_inner_error_);
#line 74 "../src/ComponentWatcher.vala"
		return;
#line 388 "ComponentWatcher.c"
	}
#line 49 "../src/ComponentWatcher.vala"
	_g_object_unref0 (launch_context);
#line 49 "../src/ComponentWatcher.vala"
	_g_object_unref0 (default_display);
#line 394 "ComponentWatcher.c"
}

static void
greeter_component_watcher_on_process_watch_exit (GreeterComponentWatcher* self,
                                                 GPid pid,
                                                 gint status)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 83 "../src/ComponentWatcher.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/ComponentWatcher.vala"
	if (pid != self->priv->pid) {
#line 85 "../src/ComponentWatcher.vala"
		return;
#line 411 "ComponentWatcher.c"
	}
#line 87 "../src/ComponentWatcher.vala"
	_tmp0_ = self->priv->command;
#line 87 "../src/ComponentWatcher.vala"
	g_message ("ComponentWatcher.vala:87: Process '%s' watch exit", _tmp0_);
#line 90 "../src/ComponentWatcher.vala"
	if (WIFEXITED (status)) {
#line 90 "../src/ComponentWatcher.vala"
		_tmp2_ = TRUE;
#line 421 "ComponentWatcher.c"
	} else {
#line 90 "../src/ComponentWatcher.vala"
		_tmp2_ = WIFSIGNALED (status);
#line 425 "ComponentWatcher.c"
	}
#line 90 "../src/ComponentWatcher.vala"
	if (_tmp2_) {
#line 90 "../src/ComponentWatcher.vala"
		_tmp1_ = TRUE;
#line 431 "ComponentWatcher.c"
	} else {
#line 90 "../src/ComponentWatcher.vala"
		_tmp1_ = WCOREDUMP (status);
#line 435 "ComponentWatcher.c"
	}
#line 90 "../src/ComponentWatcher.vala"
	if (_tmp1_) {
#line 91 "../src/ComponentWatcher.vala"
		greeter_component_watcher_terminate (self, TRUE);
#line 441 "ComponentWatcher.c"
	}
}

void
greeter_component_watcher_terminate (GreeterComponentWatcher* self,
                                     gboolean restart)
{
	GreeterComponentWatcherStatus _tmp0_;
	const gchar* _tmp1_;
	gboolean normal_exit = FALSE;
	GTimer* _tmp2_;
#line 95 "../src/ComponentWatcher.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/ComponentWatcher.vala"
	_tmp0_ = self->priv->status;
#line 96 "../src/ComponentWatcher.vala"
	if (_tmp0_ != GREETER_COMPONENT_WATCHER_STATUS_RUNNING) {
#line 97 "../src/ComponentWatcher.vala"
		return;
#line 461 "ComponentWatcher.c"
	}
#line 99 "../src/ComponentWatcher.vala"
	_tmp1_ = self->priv->command;
#line 99 "../src/ComponentWatcher.vala"
	g_message ("ComponentWatcher.vala:99: Process %s is being terminated", _tmp1_);
#line 101 "../src/ComponentWatcher.vala"
	g_spawn_close_pid (self->priv->pid);
#line 103 "../src/ComponentWatcher.vala"
	normal_exit = TRUE;
#line 105 "../src/ComponentWatcher.vala"
	_tmp2_ = self->priv->timer;
#line 105 "../src/ComponentWatcher.vala"
	if (_tmp2_ != NULL) {
#line 475 "ComponentWatcher.c"
		GTimer* _tmp3_;
		gdouble elapsed_secs = 0.0;
		GTimer* _tmp4_;
#line 106 "../src/ComponentWatcher.vala"
		_tmp3_ = self->priv->timer;
#line 106 "../src/ComponentWatcher.vala"
		g_timer_stop (_tmp3_);
#line 108 "../src/ComponentWatcher.vala"
		_tmp4_ = self->priv->timer;
#line 108 "../src/ComponentWatcher.vala"
		elapsed_secs = g_timer_elapsed (_tmp4_, NULL);
#line 109 "../src/ComponentWatcher.vala"
		g_message ("ComponentWatcher.vala:109: ET = %f secs\tMin allowed time = %f", elapsed_secs, GREETER_COMPONENT_WATCHER_CRASH_TIME_INTERVAL);
#line 110 "../src/ComponentWatcher.vala"
		if (elapsed_secs <= GREETER_COMPONENT_WATCHER_CRASH_TIME_INTERVAL) {
#line 491 "ComponentWatcher.c"
			guint _tmp5_;
			const gchar* _tmp6_;
#line 111 "../src/ComponentWatcher.vala"
			_tmp5_ = self->priv->crash_count;
#line 111 "../src/ComponentWatcher.vala"
			self->priv->crash_count = _tmp5_ + 1;
#line 112 "../src/ComponentWatcher.vala"
			normal_exit = FALSE;
#line 113 "../src/ComponentWatcher.vala"
			_tmp6_ = self->priv->command;
#line 113 "../src/ComponentWatcher.vala"
			g_critical ("ComponentWatcher.vala:113: PROCESS '%s' CRASHED (#%u)", _tmp6_, self->priv->crash_count);
#line 504 "ComponentWatcher.c"
		}
#line 117 "../src/ComponentWatcher.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 117 "../src/ComponentWatcher.vala"
		self->priv->timer = NULL;
#line 510 "ComponentWatcher.c"
	}
#line 120 "../src/ComponentWatcher.vala"
	self->priv->status = GREETER_COMPONENT_WATCHER_STATUS_TERMINATED;
#line 122 "../src/ComponentWatcher.vala"
	if (normal_exit) {
#line 123 "../src/ComponentWatcher.vala"
		greeter_component_watcher_reset_crash_count (self);
#line 518 "ComponentWatcher.c"
	}
#line 131 "../src/ComponentWatcher.vala"
	if (self->priv->crash_count > GREETER_COMPONENT_WATCHER_MAX_CRASHES) {
#line 522 "ComponentWatcher.c"
		const gchar* _tmp7_;
#line 132 "../src/ComponentWatcher.vala"
		_tmp7_ = self->priv->command;
#line 132 "../src/ComponentWatcher.vala"
		g_warning ("'%s' exceeded the maximum number of crashes allowed " "(%u). It won't be launched again", _tmp7_, GREETER_COMPONENT_WATCHER_MAX_CRASHES);
#line 134 "../src/ComponentWatcher.vala"
		return;
#line 530 "ComponentWatcher.c"
	}
#line 137 "../src/ComponentWatcher.vala"
	if (restart) {
#line 138 "../src/ComponentWatcher.vala"
		greeter_component_watcher_run (self);
#line 536 "ComponentWatcher.c"
	}
}

static void
greeter_component_watcher_class_init (GreeterComponentWatcherClass * klass,
                                      gpointer klass_data)
{
#line 23 "../src/ComponentWatcher.vala"
	greeter_component_watcher_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/ComponentWatcher.vala"
	g_type_class_adjust_private_offset (klass, &GreeterComponentWatcher_private_offset);
#line 23 "../src/ComponentWatcher.vala"
	G_OBJECT_CLASS (klass)->finalize = greeter_component_watcher_finalize;
#line 550 "ComponentWatcher.c"
}

static void
greeter_component_watcher_instance_init (GreeterComponentWatcher * self,
                                         gpointer klass)
{
#line 23 "../src/ComponentWatcher.vala"
	self->priv = greeter_component_watcher_get_instance_private (self);
#line 34 "../src/ComponentWatcher.vala"
	self->priv->crash_count = (guint) 0;
#line 36 "../src/ComponentWatcher.vala"
	self->priv->status = GREETER_COMPONENT_WATCHER_STATUS_INACTIVE;
#line 37 "../src/ComponentWatcher.vala"
	self->priv->pid = (GPid) -1;
#line 38 "../src/ComponentWatcher.vala"
	self->priv->timer = NULL;
#line 567 "ComponentWatcher.c"
}

static void
greeter_component_watcher_finalize (GObject * obj)
{
	GreeterComponentWatcher * self;
#line 23 "../src/ComponentWatcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_COMPONENT_WATCHER, GreeterComponentWatcher);
#line 35 "../src/ComponentWatcher.vala"
	_g_free0 (self->priv->command);
#line 38 "../src/ComponentWatcher.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 23 "../src/ComponentWatcher.vala"
	G_OBJECT_CLASS (greeter_component_watcher_parent_class)->finalize (obj);
#line 582 "ComponentWatcher.c"
}

GType
greeter_component_watcher_get_type (void)
{
	static volatile gsize greeter_component_watcher_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_component_watcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GreeterComponentWatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_component_watcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterComponentWatcher), 0, (GInstanceInitFunc) greeter_component_watcher_instance_init, NULL };
		GType greeter_component_watcher_type_id;
		greeter_component_watcher_type_id = g_type_register_static (G_TYPE_OBJECT, "GreeterComponentWatcher", &g_define_type_info, 0);
		GreeterComponentWatcher_private_offset = g_type_add_instance_private (greeter_component_watcher_type_id, sizeof (GreeterComponentWatcherPrivate));
		g_once_init_leave (&greeter_component_watcher_type_id__volatile, greeter_component_watcher_type_id);
	}
	return greeter_component_watcher_type_id__volatile;
}

