/* DummyGateway.c generated by valac 0.43.6, the Vala compiler
 * generated from DummyGateway.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;
typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())
typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())
typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

#define TYPE_DUMMY_GATEWAY (dummy_gateway_get_type ())
#define DUMMY_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUMMY_GATEWAY, DummyGateway))
#define DUMMY_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUMMY_GATEWAY, DummyGatewayClass))
#define IS_DUMMY_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUMMY_GATEWAY))
#define IS_DUMMY_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUMMY_GATEWAY))
#define DUMMY_GATEWAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUMMY_GATEWAY, DummyGatewayClass))

typedef struct _DummyGateway DummyGateway;
typedef struct _DummyGatewayClass DummyGatewayClass;
typedef struct _DummyGatewayPrivate DummyGatewayPrivate;
enum  {
	DUMMY_GATEWAY_0_PROPERTY,
	DUMMY_GATEWAY_HIDE_USERS_PROPERTY,
	DUMMY_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY,
	DUMMY_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY,
	DUMMY_GATEWAY_LOCK_PROPERTY,
	DUMMY_GATEWAY_DEFAULT_SESSION_PROPERTY,
	DUMMY_GATEWAY_SELECT_USER_PROPERTY,
	DUMMY_GATEWAY_NUM_PROPERTIES
};
static GParamSpec* dummy_gateway_properties[DUMMY_GATEWAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

struct _DummyGateway {
	GObject parent_instance;
	DummyGatewayPrivate * priv;
};

struct _DummyGatewayClass {
	GObjectClass parent_class;
};

struct _DummyGatewayPrivate {
	LoginMask* last_login_mask;
	gboolean last_was_guest;
};

struct _Block5Data {
	int _ref_count_;
	DummyGateway* self;
	LoginMask* mask;
	gboolean guest;
};

static gint DummyGateway_private_offset;
static gpointer dummy_gateway_parent_class = NULL;
static LoginGatewayIface * dummy_gateway_login_gateway_parent_iface = NULL;

GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
GType dummy_gateway_get_type (void) G_GNUC_CONST;
static void dummy_gateway_real_login_with_mask (LoginGateway* base,
                                         LoginMask* mask,
                                         gboolean guest);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
void login_mask_login_aborted (LoginMask* self);
static gboolean __lambda28_ (Block5Data* _data5_);
void login_mask_show_prompt (LoginMask* self,
                             PromptType type,
                             PromptText prompttext,
                             const gchar* text);
static gboolean ___lambda28__gsource_func (gpointer self);
static void dummy_gateway_real_respond (LoginGateway* base,
                                 const gchar* message);
static gboolean ___lambda29_ (DummyGateway* self);
static gboolean ____lambda29__gsource_func (gpointer self);
static gboolean ___lambda30_ (DummyGateway* self);
void login_mask_not_authenticated (LoginMask* self);
static gboolean ____lambda30__gsource_func (gpointer self);
static void dummy_gateway_real_start_session (LoginGateway* base);
DummyGateway* dummy_gateway_new (void);
DummyGateway* dummy_gateway_construct (GType object_type);
static void dummy_gateway_finalize (GObject * obj);
gboolean login_gateway_get_hide_users (LoginGateway* self);
gboolean login_gateway_get_has_guest_account (LoginGateway* self);
gboolean login_gateway_get_show_manual_login (LoginGateway* self);
gboolean login_gateway_get_lock (LoginGateway* self);
const gchar* login_gateway_get_default_session (LoginGateway* self);
const gchar* login_gateway_get_select_user (LoginGateway* self);
static void _vala_dummy_gateway_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
dummy_gateway_get_instance_private (DummyGateway* self)
{
	return G_STRUCT_MEMBER_P (self, DummyGateway_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/Gateways/DummyGateway.vala"
	return self ? g_object_ref (self) : NULL;
#line 201 "DummyGateway.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 37 "../src/Gateways/DummyGateway.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 37 "../src/Gateways/DummyGateway.vala"
	return _data5_;
#line 211 "DummyGateway.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 37 "../src/Gateways/DummyGateway.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 221 "DummyGateway.c"
		DummyGateway* self;
#line 37 "../src/Gateways/DummyGateway.vala"
		self = _data5_->self;
#line 37 "../src/Gateways/DummyGateway.vala"
		_g_object_unref0 (_data5_->mask);
#line 37 "../src/Gateways/DummyGateway.vala"
		_g_object_unref0 (self);
#line 37 "../src/Gateways/DummyGateway.vala"
		g_slice_free (Block5Data, _data5_);
#line 231 "DummyGateway.c"
	}
}

static gboolean
__lambda28_ (Block5Data* _data5_)
{
	DummyGateway* self;
	gboolean result = FALSE;
	PromptType _tmp0_ = 0;
	PromptText _tmp1_ = 0;
#line 43 "../src/Gateways/DummyGateway.vala"
	self = _data5_->self;
#line 44 "../src/Gateways/DummyGateway.vala"
	if (_data5_->guest) {
#line 44 "../src/Gateways/DummyGateway.vala"
		_tmp0_ = PROMPT_TYPE_CONFIRM_LOGIN;
#line 248 "DummyGateway.c"
	} else {
#line 44 "../src/Gateways/DummyGateway.vala"
		_tmp0_ = PROMPT_TYPE_SECRET;
#line 252 "DummyGateway.c"
	}
#line 44 "../src/Gateways/DummyGateway.vala"
	if (_data5_->guest) {
#line 44 "../src/Gateways/DummyGateway.vala"
		_tmp1_ = PROMPT_TEXT_OTHER;
#line 258 "DummyGateway.c"
	} else {
#line 44 "../src/Gateways/DummyGateway.vala"
		_tmp1_ = PROMPT_TEXT_PASSWORD;
#line 262 "DummyGateway.c"
	}
#line 44 "../src/Gateways/DummyGateway.vala"
	login_mask_show_prompt (_data5_->mask, _tmp0_, _tmp1_, "");
#line 45 "../src/Gateways/DummyGateway.vala"
	result = FALSE;
#line 45 "../src/Gateways/DummyGateway.vala"
	return result;
#line 270 "DummyGateway.c"
}

static gboolean
___lambda28__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda28_ (self);
#line 43 "../src/Gateways/DummyGateway.vala"
	return result;
#line 280 "DummyGateway.c"
}

static void
dummy_gateway_real_login_with_mask (LoginGateway* base,
                                    LoginMask* mask,
                                    gboolean guest)
{
	DummyGateway * self;
	Block5Data* _data5_;
	LoginMask* _tmp0_;
	LoginMask* _tmp1_;
	LoginMask* _tmp2_;
#line 37 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 37 "../src/Gateways/DummyGateway.vala"
	g_return_if_fail (mask != NULL);
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_->_ref_count_ = 1;
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_->self = g_object_ref (self);
#line 37 "../src/Gateways/DummyGateway.vala"
	_tmp0_ = _g_object_ref0 (mask);
#line 37 "../src/Gateways/DummyGateway.vala"
	_g_object_unref0 (_data5_->mask);
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_->mask = _tmp0_;
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_->guest = guest;
#line 38 "../src/Gateways/DummyGateway.vala"
	_tmp1_ = self->priv->last_login_mask;
#line 38 "../src/Gateways/DummyGateway.vala"
	if (_tmp1_ != NULL) {
#line 39 "../src/Gateways/DummyGateway.vala"
		login_mask_login_aborted (_data5_->mask);
#line 317 "DummyGateway.c"
	}
#line 41 "../src/Gateways/DummyGateway.vala"
	self->priv->last_was_guest = _data5_->guest;
#line 42 "../src/Gateways/DummyGateway.vala"
	_tmp2_ = _g_object_ref0 (_data5_->mask);
#line 42 "../src/Gateways/DummyGateway.vala"
	_g_object_unref0 (self->priv->last_login_mask);
#line 42 "../src/Gateways/DummyGateway.vala"
	self->priv->last_login_mask = _tmp2_;
#line 43 "../src/Gateways/DummyGateway.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda28__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 37 "../src/Gateways/DummyGateway.vala"
	block5_data_unref (_data5_);
#line 37 "../src/Gateways/DummyGateway.vala"
	_data5_ = NULL;
#line 333 "DummyGateway.c"
}

static gboolean
___lambda29_ (DummyGateway* self)
{
	gboolean result = FALSE;
#line 52 "../src/Gateways/DummyGateway.vala"
	g_signal_emit_by_name ((LoginGateway*) self, "login-successful");
#line 53 "../src/Gateways/DummyGateway.vala"
	result = FALSE;
#line 53 "../src/Gateways/DummyGateway.vala"
	return result;
#line 346 "DummyGateway.c"
}

static gboolean
____lambda29__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda29_ ((DummyGateway*) self);
#line 51 "../src/Gateways/DummyGateway.vala"
	return result;
#line 356 "DummyGateway.c"
}

static gboolean
___lambda30_ (DummyGateway* self)
{
	gboolean result = FALSE;
	LoginMask* _tmp0_;
#line 57 "../src/Gateways/DummyGateway.vala"
	_tmp0_ = self->priv->last_login_mask;
#line 57 "../src/Gateways/DummyGateway.vala"
	login_mask_not_authenticated (_tmp0_);
#line 58 "../src/Gateways/DummyGateway.vala"
	result = FALSE;
#line 58 "../src/Gateways/DummyGateway.vala"
	return result;
#line 372 "DummyGateway.c"
}

static gboolean
____lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda30_ ((DummyGateway*) self);
#line 56 "../src/Gateways/DummyGateway.vala"
	return result;
#line 382 "DummyGateway.c"
}

static void
dummy_gateway_real_respond (LoginGateway* base,
                            const gchar* message)
{
	DummyGateway * self;
#line 49 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 49 "../src/Gateways/DummyGateway.vala"
	g_return_if_fail (message != NULL);
#line 50 "../src/Gateways/DummyGateway.vala"
	if (self->priv->last_was_guest) {
#line 51 "../src/Gateways/DummyGateway.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda29__gsource_func, g_object_ref (self), g_object_unref);
#line 398 "DummyGateway.c"
	} else {
#line 56 "../src/Gateways/DummyGateway.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda30__gsource_func, g_object_ref (self), g_object_unref);
#line 402 "DummyGateway.c"
	}
}

static void
dummy_gateway_real_start_session (LoginGateway* base)
{
	DummyGateway * self;
#line 63 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 64 "../src/Gateways/DummyGateway.vala"
	g_message ("DummyGateway.vala:64: Started session");
#line 65 "../src/Gateways/DummyGateway.vala"
	exit (EXIT_SUCCESS);
#line 416 "DummyGateway.c"
}

DummyGateway*
dummy_gateway_construct (GType object_type)
{
	DummyGateway * self = NULL;
#line 24 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) g_object_new (object_type, NULL);
#line 24 "../src/Gateways/DummyGateway.vala"
	return self;
#line 427 "DummyGateway.c"
}

DummyGateway*
dummy_gateway_new (void)
{
#line 24 "../src/Gateways/DummyGateway.vala"
	return dummy_gateway_construct (TYPE_DUMMY_GATEWAY);
#line 435 "DummyGateway.c"
}

static gboolean
dummy_gateway_real_get_hide_users (LoginGateway* base)
{
	gboolean result;
	DummyGateway* self;
#line 26 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 26 "../src/Gateways/DummyGateway.vala"
	result = FALSE;
#line 26 "../src/Gateways/DummyGateway.vala"
	return result;
#line 449 "DummyGateway.c"
}

static gboolean
dummy_gateway_real_get_has_guest_account (LoginGateway* base)
{
	gboolean result;
	DummyGateway* self;
#line 27 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 27 "../src/Gateways/DummyGateway.vala"
	result = TRUE;
#line 27 "../src/Gateways/DummyGateway.vala"
	return result;
#line 463 "DummyGateway.c"
}

static gboolean
dummy_gateway_real_get_show_manual_login (LoginGateway* base)
{
	gboolean result;
	DummyGateway* self;
#line 28 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 28 "../src/Gateways/DummyGateway.vala"
	result = TRUE;
#line 28 "../src/Gateways/DummyGateway.vala"
	return result;
#line 477 "DummyGateway.c"
}

static gboolean
dummy_gateway_real_get_lock (LoginGateway* base)
{
	gboolean result;
	DummyGateway* self;
#line 29 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 29 "../src/Gateways/DummyGateway.vala"
	result = FALSE;
#line 29 "../src/Gateways/DummyGateway.vala"
	return result;
#line 491 "DummyGateway.c"
}

static const gchar*
dummy_gateway_real_get_default_session (LoginGateway* base)
{
	const gchar* result;
	DummyGateway* self;
#line 30 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 30 "../src/Gateways/DummyGateway.vala"
	result = "";
#line 30 "../src/Gateways/DummyGateway.vala"
	return result;
#line 505 "DummyGateway.c"
}

static const gchar*
dummy_gateway_real_get_select_user (LoginGateway* base)
{
	const gchar* result;
	DummyGateway* self;
#line 31 "../src/Gateways/DummyGateway.vala"
	self = (DummyGateway*) base;
#line 31 "../src/Gateways/DummyGateway.vala"
	result = NULL;
#line 31 "../src/Gateways/DummyGateway.vala"
	return result;
#line 519 "DummyGateway.c"
}

static void
dummy_gateway_class_init (DummyGatewayClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/Gateways/DummyGateway.vala"
	dummy_gateway_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Gateways/DummyGateway.vala"
	g_type_class_adjust_private_offset (klass, &DummyGateway_private_offset);
#line 24 "../src/Gateways/DummyGateway.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dummy_gateway_get_property;
#line 24 "../src/Gateways/DummyGateway.vala"
	G_OBJECT_CLASS (klass)->finalize = dummy_gateway_finalize;
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_HIDE_USERS_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_HIDE_USERS_PROPERTY] = g_param_spec_boolean ("hide-users", "hide-users", "hide-users", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY] = g_param_spec_boolean ("has-guest-account", "has-guest-account", "has-guest-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY] = g_param_spec_boolean ("show-manual-login", "show-manual-login", "show-manual-login", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_LOCK_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_LOCK_PROPERTY] = g_param_spec_boolean ("lock", "lock", "lock", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_DEFAULT_SESSION_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_DEFAULT_SESSION_PROPERTY] = g_param_spec_string ("default-session", "default-session", "default-session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/DummyGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUMMY_GATEWAY_SELECT_USER_PROPERTY, dummy_gateway_properties[DUMMY_GATEWAY_SELECT_USER_PROPERTY] = g_param_spec_string ("select-user", "select-user", "select-user", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 546 "DummyGateway.c"
}

static void
dummy_gateway_login_gateway_interface_init (LoginGatewayIface * iface,
                                            gpointer iface_data)
{
#line 24 "../src/Gateways/DummyGateway.vala"
	dummy_gateway_login_gateway_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->login_with_mask = (void (*) (LoginGateway*, LoginMask*, gboolean)) dummy_gateway_real_login_with_mask;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->respond = (void (*) (LoginGateway*, const gchar*)) dummy_gateway_real_respond;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->start_session = (void (*) (LoginGateway*)) dummy_gateway_real_start_session;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_hide_users = dummy_gateway_real_get_hide_users;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_has_guest_account = dummy_gateway_real_get_has_guest_account;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_show_manual_login = dummy_gateway_real_get_show_manual_login;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_lock = dummy_gateway_real_get_lock;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_default_session = dummy_gateway_real_get_default_session;
#line 24 "../src/Gateways/DummyGateway.vala"
	iface->get_select_user = dummy_gateway_real_get_select_user;
#line 573 "DummyGateway.c"
}

static void
dummy_gateway_instance_init (DummyGateway * self,
                             gpointer klass)
{
#line 24 "../src/Gateways/DummyGateway.vala"
	self->priv = dummy_gateway_get_instance_private (self);
#line 35 "../src/Gateways/DummyGateway.vala"
	self->priv->last_was_guest = TRUE;
#line 584 "DummyGateway.c"
}

static void
dummy_gateway_finalize (GObject * obj)
{
	DummyGateway * self;
#line 24 "../src/Gateways/DummyGateway.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUMMY_GATEWAY, DummyGateway);
#line 33 "../src/Gateways/DummyGateway.vala"
	_g_object_unref0 (self->priv->last_login_mask);
#line 24 "../src/Gateways/DummyGateway.vala"
	G_OBJECT_CLASS (dummy_gateway_parent_class)->finalize (obj);
#line 597 "DummyGateway.c"
}

/**
 * For testing purposes a Gateway which only allows the guest to login.
 */
GType
dummy_gateway_get_type (void)
{
	static volatile gsize dummy_gateway_type_id__volatile = 0;
	if (g_once_init_enter (&dummy_gateway_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DummyGatewayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dummy_gateway_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DummyGateway), 0, (GInstanceInitFunc) dummy_gateway_instance_init, NULL };
		static const GInterfaceInfo login_gateway_info = { (GInterfaceInitFunc) dummy_gateway_login_gateway_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType dummy_gateway_type_id;
		dummy_gateway_type_id = g_type_register_static (G_TYPE_OBJECT, "DummyGateway", &g_define_type_info, 0);
		g_type_add_interface_static (dummy_gateway_type_id, TYPE_LOGIN_GATEWAY, &login_gateway_info);
		DummyGateway_private_offset = g_type_add_instance_private (dummy_gateway_type_id, sizeof (DummyGatewayPrivate));
		g_once_init_leave (&dummy_gateway_type_id__volatile, dummy_gateway_type_id);
	}
	return dummy_gateway_type_id__volatile;
}

static void
_vala_dummy_gateway_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DummyGateway * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUMMY_GATEWAY, DummyGateway);
#line 24 "../src/Gateways/DummyGateway.vala"
	switch (property_id) {
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_HIDE_USERS_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_boolean (value, login_gateway_get_hide_users ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_boolean (value, login_gateway_get_has_guest_account ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_boolean (value, login_gateway_get_show_manual_login ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_LOCK_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_boolean (value, login_gateway_get_lock ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_DEFAULT_SESSION_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_string (value, login_gateway_get_default_session ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 24 "../src/Gateways/DummyGateway.vala"
		case DUMMY_GATEWAY_SELECT_USER_PROPERTY:
#line 24 "../src/Gateways/DummyGateway.vala"
		g_value_set_string (value, login_gateway_get_select_user ((LoginGateway*) self));
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 665 "DummyGateway.c"
		default:
#line 24 "../src/Gateways/DummyGateway.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Gateways/DummyGateway.vala"
		break;
#line 671 "DummyGateway.c"
	}
}

