/* LightDMGateway.c generated by valac 0.43.6, the Vala compiler
 * generated from LightDMGateway.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;
typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())
typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())
typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

#define TYPE_LIGHT_DM_GATEWAY (light_dm_gateway_get_type ())
#define LIGHT_DM_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIGHT_DM_GATEWAY, LightDMGateway))
#define LIGHT_DM_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIGHT_DM_GATEWAY, LightDMGatewayClass))
#define IS_LIGHT_DM_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIGHT_DM_GATEWAY))
#define IS_LIGHT_DM_GATEWAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIGHT_DM_GATEWAY))
#define LIGHT_DM_GATEWAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIGHT_DM_GATEWAY, LightDMGatewayClass))

typedef struct _LightDMGateway LightDMGateway;
typedef struct _LightDMGatewayClass LightDMGatewayClass;
typedef struct _LightDMGatewayPrivate LightDMGatewayPrivate;
enum  {
	LIGHT_DM_GATEWAY_0_PROPERTY,
	LIGHT_DM_GATEWAY_HIDE_USERS_PROPERTY,
	LIGHT_DM_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY,
	LIGHT_DM_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY,
	LIGHT_DM_GATEWAY_LOCK_PROPERTY,
	LIGHT_DM_GATEWAY_DEFAULT_SESSION_PROPERTY,
	LIGHT_DM_GATEWAY_SELECT_USER_PROPERTY,
	LIGHT_DM_GATEWAY_NUM_PROPERTIES
};
static GParamSpec* light_dm_gateway_properties[LIGHT_DM_GATEWAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PANTHEON_GREETER (pantheon_greeter_get_type ())
#define PANTHEON_GREETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PANTHEON_GREETER, PantheonGreeter))
#define PANTHEON_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PANTHEON_GREETER, PantheonGreeterClass))
#define IS_PANTHEON_GREETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PANTHEON_GREETER))
#define IS_PANTHEON_GREETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PANTHEON_GREETER))
#define PANTHEON_GREETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PANTHEON_GREETER, PantheonGreeterClass))

typedef struct _PantheonGreeter PantheonGreeter;
typedef struct _PantheonGreeterClass PantheonGreeterClass;

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

struct _LightDMGateway {
	GObject parent_instance;
	LightDMGatewayPrivate * priv;
};

struct _LightDMGatewayClass {
	GObjectClass parent_class;
};

struct _LightDMGatewayPrivate {
	LoginMask* _current_login;
	gboolean had_prompt;
	gboolean awaiting_confirmation;
	gboolean awaiting_start_session;
	LightDMGreeter* lightdm;
};

static gint LightDMGateway_private_offset;
static gpointer light_dm_gateway_parent_class = NULL;
static LoginGatewayIface * light_dm_gateway_login_gateway_parent_iface = NULL;

GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
GType light_dm_gateway_get_type (void) G_GNUC_CONST;
LightDMGateway* light_dm_gateway_new (void);
LightDMGateway* light_dm_gateway_construct (GType object_type);
static void light_dm_gateway_show_message (LightDMGateway* self,
                                    const gchar* text,
                                    LightDMMessageType type);
static void _light_dm_gateway_show_message_lightdm_greeter_show_message (LightDMGreeter* _sender,
                                                                  const gchar* text,
                                                                  LightDMMessageType type,
                                                                  gpointer self);
static void light_dm_gateway_show_prompt (LightDMGateway* self,
                                   const gchar* text,
                                   LightDMPromptType type);
static void _light_dm_gateway_show_prompt_lightdm_greeter_show_prompt (LightDMGreeter* _sender,
                                                                const gchar* text,
                                                                LightDMPromptType type,
                                                                gpointer self);
static void light_dm_gateway_authentication (LightDMGateway* self);
static void _light_dm_gateway_authentication_lightdm_greeter_authentication_complete (LightDMGreeter* _sender,
                                                                               gpointer self);
static void light_dm_gateway_real_login_with_mask (LoginGateway* base,
                                            LoginMask* login,
                                            gboolean guest);
static LoginMask* light_dm_gateway_get_current_login (LightDMGateway* self);
void login_mask_login_aborted (LoginMask* self);
static void light_dm_gateway_set_current_login (LightDMGateway* self,
                                         LoginMask* value);
const gchar* login_mask_get_login_name (LoginMask* self);
static void light_dm_gateway_real_respond (LoginGateway* base,
                                    const gchar* text);
const gchar* lightdm_message_type_to_string (LightDMMessageType self);
static MessageText light_dm_gateway_string_to_messagetext (LightDMGateway* self,
                                                    const gchar* text);
static void light_dm_gateway_send_prompt (LightDMGateway* self,
                                   PromptType type,
                                   PromptText prompttext,
                                   const gchar* text);
void login_mask_show_message (LoginMask* self,
                              LightDMMessageType type,
                              MessageText messagetext,
                              const gchar* text);
const gchar* lightdm_prompt_type_to_string (LightDMPromptType self);
static PromptType light_dm_gateway_lightdm_prompttype_to_prompttype (LightDMGateway* self,
                                                              LightDMPromptType type);
static PromptText light_dm_gateway_string_to_prompttext (LightDMGateway* self,
                                                  const gchar* text);
void login_mask_show_prompt (LoginMask* self,
                             PromptType type,
                             PromptText prompttext,
                             const gchar* text);
gboolean light_dm_gateway_check_fprintd_string (LightDMGateway* self,
                                                const gchar* text,
                                                const gchar* action,
                                                const gchar* position);
static void light_dm_gateway_real_start_session (LoginGateway* base);
const gchar* login_mask_get_login_session (LoginMask* self);
GType pantheon_greeter_get_type (void) G_GNUC_CONST;
PantheonGreeter* pantheon_greeter_get_instance (void);
void pantheon_greeter_set_greeter_state (PantheonGreeter* self,
                                         const gchar* key,
                                         const gchar* value);
void login_mask_not_authenticated (LoginMask* self);
static void light_dm_gateway_finalize (GObject * obj);
gboolean login_gateway_get_hide_users (LoginGateway* self);
gboolean login_gateway_get_has_guest_account (LoginGateway* self);
gboolean login_gateway_get_show_manual_login (LoginGateway* self);
gboolean login_gateway_get_lock (LoginGateway* self);
const gchar* login_gateway_get_default_session (LoginGateway* self);
const gchar* login_gateway_get_select_user (LoginGateway* self);
static void _vala_light_dm_gateway_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_light_dm_gateway_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
light_dm_gateway_get_instance_private (LightDMGateway* self)
{
	return G_STRUCT_MEMBER_P (self, LightDMGateway_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1513 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	result = self;
#line 1514 "glib-2.0.vapi"
	return result;
#line 264 "LightDMGateway.c"
}

static void
_light_dm_gateway_show_message_lightdm_greeter_show_message (LightDMGreeter* _sender,
                                                             const gchar* text,
                                                             LightDMMessageType type,
                                                             gpointer self)
{
#line 94 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_show_message ((LightDMGateway*) self, text, type);
#line 275 "LightDMGateway.c"
}

static void
_light_dm_gateway_show_prompt_lightdm_greeter_show_prompt (LightDMGreeter* _sender,
                                                           const gchar* text,
                                                           LightDMPromptType type,
                                                           gpointer self)
{
#line 95 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_show_prompt ((LightDMGateway*) self, text, type);
#line 286 "LightDMGateway.c"
}

static void
_light_dm_gateway_authentication_lightdm_greeter_authentication_complete (LightDMGreeter* _sender,
                                                                          gpointer self)
{
#line 96 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_authentication ((LightDMGateway*) self);
#line 295 "LightDMGateway.c"
}

LightDMGateway*
light_dm_gateway_construct (GType object_type)
{
	LightDMGateway * self = NULL;
	LightDMGreeter* _tmp0_;
	LightDMGreeter* _tmp7_;
	LightDMGreeter* _tmp8_;
	LightDMGreeter* _tmp9_;
	GError * _inner_error_ = NULL;
#line 83 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) g_object_new (object_type, NULL);
#line 84 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:84: Connecting to LightDM...");
#line 85 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = lightdm_greeter_new ();
#line 85 "../src/Gateways/LightDMGateway.vala"
	_g_object_unref0 (self->priv->lightdm);
#line 85 "../src/Gateways/LightDMGateway.vala"
	self->priv->lightdm = _tmp0_;
#line 317 "LightDMGateway.c"
	{
		LightDMGreeter* _tmp1_;
#line 88 "../src/Gateways/LightDMGateway.vala"
		_tmp1_ = self->priv->lightdm;
#line 88 "../src/Gateways/LightDMGateway.vala"
		lightdm_greeter_connect_to_daemon_sync (_tmp1_, &_inner_error_);
#line 88 "../src/Gateways/LightDMGateway.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 326 "LightDMGateway.c"
			goto __catch12_g_error;
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 87 "../src/Gateways/LightDMGateway.vala"
		e = _inner_error_;
#line 87 "../src/Gateways/LightDMGateway.vala"
		_inner_error_ = NULL;
#line 90 "../src/Gateways/LightDMGateway.vala"
		_tmp2_ = e;
#line 90 "../src/Gateways/LightDMGateway.vala"
		_tmp3_ = _tmp2_->message;
#line 90 "../src/Gateways/LightDMGateway.vala"
		_tmp4_ = string_to_string (_tmp3_);
#line 90 "../src/Gateways/LightDMGateway.vala"
		_tmp5_ = g_strconcat ("Couldn't connect to lightdm: ", _tmp4_, NULL);
#line 90 "../src/Gateways/LightDMGateway.vala"
		_tmp6_ = _tmp5_;
#line 90 "../src/Gateways/LightDMGateway.vala"
		g_warning ("LightDMGateway.vala:90: %s", _tmp6_);
#line 90 "../src/Gateways/LightDMGateway.vala"
		_g_free0 (_tmp6_);
#line 91 "../src/Gateways/LightDMGateway.vala"
		exit (EXIT_FAILURE);
#line 87 "../src/Gateways/LightDMGateway.vala"
		_g_error_free0 (e);
#line 361 "LightDMGateway.c"
	}
	__finally12:
#line 87 "../src/Gateways/LightDMGateway.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 87 "../src/Gateways/LightDMGateway.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 87 "../src/Gateways/LightDMGateway.vala"
		g_clear_error (&_inner_error_);
#line 87 "../src/Gateways/LightDMGateway.vala"
		return NULL;
#line 372 "LightDMGateway.c"
	}
#line 93 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:93: Successfully connected to LightDM.");
#line 94 "../src/Gateways/LightDMGateway.vala"
	_tmp7_ = self->priv->lightdm;
#line 94 "../src/Gateways/LightDMGateway.vala"
	g_signal_connect_object (_tmp7_, "show-message", (GCallback) _light_dm_gateway_show_message_lightdm_greeter_show_message, self, 0);
#line 95 "../src/Gateways/LightDMGateway.vala"
	_tmp8_ = self->priv->lightdm;
#line 95 "../src/Gateways/LightDMGateway.vala"
	g_signal_connect_object (_tmp8_, "show-prompt", (GCallback) _light_dm_gateway_show_prompt_lightdm_greeter_show_prompt, self, 0);
#line 96 "../src/Gateways/LightDMGateway.vala"
	_tmp9_ = self->priv->lightdm;
#line 96 "../src/Gateways/LightDMGateway.vala"
	g_signal_connect_object (_tmp9_, "authentication-complete", (GCallback) _light_dm_gateway_authentication_lightdm_greeter_authentication_complete, self, 0);
#line 83 "../src/Gateways/LightDMGateway.vala"
	return self;
#line 390 "LightDMGateway.c"
}

LightDMGateway*
light_dm_gateway_new (void)
{
#line 83 "../src/Gateways/LightDMGateway.vala"
	return light_dm_gateway_construct (TYPE_LIGHT_DM_GATEWAY);
#line 398 "LightDMGateway.c"
}

static void
light_dm_gateway_real_login_with_mask (LoginGateway* base,
                                       LoginMask* login,
                                       gboolean guest)
{
	LightDMGateway * self;
	LoginMask* _tmp0_;
	GError * _inner_error_ = NULL;
#line 99 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 99 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (login != NULL);
#line 100 "../src/Gateways/LightDMGateway.vala"
	if (self->priv->awaiting_start_session) {
#line 101 "../src/Gateways/LightDMGateway.vala"
		g_warning ("LightDMGateway.vala:101: Got login_with_mask while awaiting start_sess" \
"ion!");
#line 102 "../src/Gateways/LightDMGateway.vala"
		return;
#line 419 "LightDMGateway.c"
	}
#line 105 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:105: %s", "Starting authentication...");
#line 106 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->_current_login;
#line 106 "../src/Gateways/LightDMGateway.vala"
	if (_tmp0_ != NULL) {
#line 427 "LightDMGateway.c"
		LoginMask* _tmp1_;
#line 107 "../src/Gateways/LightDMGateway.vala"
		_tmp1_ = self->priv->_current_login;
#line 107 "../src/Gateways/LightDMGateway.vala"
		login_mask_login_aborted (_tmp1_);
#line 433 "LightDMGateway.c"
	}
#line 109 "../src/Gateways/LightDMGateway.vala"
	self->priv->had_prompt = FALSE;
#line 110 "../src/Gateways/LightDMGateway.vala"
	self->priv->awaiting_confirmation = FALSE;
#line 112 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_set_current_login (self, login);
#line 113 "../src/Gateways/LightDMGateway.vala"
	if (guest) {
#line 443 "LightDMGateway.c"
		{
			LightDMGreeter* _tmp2_;
#line 115 "../src/Gateways/LightDMGateway.vala"
			_tmp2_ = self->priv->lightdm;
#line 115 "../src/Gateways/LightDMGateway.vala"
			lightdm_greeter_authenticate_as_guest (_tmp2_, &_inner_error_);
#line 115 "../src/Gateways/LightDMGateway.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 452 "LightDMGateway.c"
				goto __catch13_g_error;
			}
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 114 "../src/Gateways/LightDMGateway.vala"
			e = _inner_error_;
#line 114 "../src/Gateways/LightDMGateway.vala"
			_inner_error_ = NULL;
#line 117 "../src/Gateways/LightDMGateway.vala"
			_tmp3_ = e;
#line 117 "../src/Gateways/LightDMGateway.vala"
			_tmp4_ = _tmp3_->message;
#line 117 "../src/Gateways/LightDMGateway.vala"
			g_warning ("LightDMGateway.vala:117: %s", _tmp4_);
#line 114 "../src/Gateways/LightDMGateway.vala"
			_g_error_free0 (e);
#line 474 "LightDMGateway.c"
		}
		__finally13:
#line 114 "../src/Gateways/LightDMGateway.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 114 "../src/Gateways/LightDMGateway.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 114 "../src/Gateways/LightDMGateway.vala"
			g_clear_error (&_inner_error_);
#line 114 "../src/Gateways/LightDMGateway.vala"
			return;
#line 485 "LightDMGateway.c"
		}
	} else {
		{
			LightDMGreeter* _tmp5_;
			LoginMask* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 122 "../src/Gateways/LightDMGateway.vala"
			_tmp5_ = self->priv->lightdm;
#line 122 "../src/Gateways/LightDMGateway.vala"
			_tmp6_ = self->priv->_current_login;
#line 122 "../src/Gateways/LightDMGateway.vala"
			_tmp7_ = login_mask_get_login_name (_tmp6_);
#line 122 "../src/Gateways/LightDMGateway.vala"
			_tmp8_ = _tmp7_;
#line 122 "../src/Gateways/LightDMGateway.vala"
			lightdm_greeter_authenticate (_tmp5_, _tmp8_, &_inner_error_);
#line 122 "../src/Gateways/LightDMGateway.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 505 "LightDMGateway.c"
				goto __catch14_g_error;
			}
		}
		goto __finally14;
		__catch14_g_error:
		{
			GError* e = NULL;
			GError* _tmp9_;
			const gchar* _tmp10_;
#line 121 "../src/Gateways/LightDMGateway.vala"
			e = _inner_error_;
#line 121 "../src/Gateways/LightDMGateway.vala"
			_inner_error_ = NULL;
#line 124 "../src/Gateways/LightDMGateway.vala"
			_tmp9_ = e;
#line 124 "../src/Gateways/LightDMGateway.vala"
			_tmp10_ = _tmp9_->message;
#line 124 "../src/Gateways/LightDMGateway.vala"
			g_warning ("LightDMGateway.vala:124: %s", _tmp10_);
#line 121 "../src/Gateways/LightDMGateway.vala"
			_g_error_free0 (e);
#line 527 "LightDMGateway.c"
		}
		__finally14:
#line 121 "../src/Gateways/LightDMGateway.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 121 "../src/Gateways/LightDMGateway.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 121 "../src/Gateways/LightDMGateway.vala"
			g_clear_error (&_inner_error_);
#line 121 "../src/Gateways/LightDMGateway.vala"
			return;
#line 538 "LightDMGateway.c"
		}
	}
}

static void
light_dm_gateway_real_respond (LoginGateway* base,
                               const gchar* text)
{
	LightDMGateway * self;
	GError * _inner_error_ = NULL;
#line 130 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 130 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (text != NULL);
#line 131 "../src/Gateways/LightDMGateway.vala"
	if (self->priv->awaiting_start_session) {
#line 132 "../src/Gateways/LightDMGateway.vala"
		g_warning ("LightDMGateway.vala:132: Got respond while awaiting start_session!");
#line 133 "../src/Gateways/LightDMGateway.vala"
		return;
#line 559 "LightDMGateway.c"
	}
#line 136 "../src/Gateways/LightDMGateway.vala"
	if (self->priv->awaiting_confirmation) {
#line 137 "../src/Gateways/LightDMGateway.vala"
		g_warning ("LightDMGateway.vala:137: Got user-interaction. Starting session");
#line 138 "../src/Gateways/LightDMGateway.vala"
		self->priv->awaiting_start_session = TRUE;
#line 139 "../src/Gateways/LightDMGateway.vala"
		g_signal_emit_by_name ((LoginGateway*) self, "login-successful");
#line 569 "LightDMGateway.c"
	} else {
		{
			LightDMGreeter* _tmp0_;
#line 143 "../src/Gateways/LightDMGateway.vala"
			_tmp0_ = self->priv->lightdm;
#line 143 "../src/Gateways/LightDMGateway.vala"
			lightdm_greeter_respond (_tmp0_, text, &_inner_error_);
#line 143 "../src/Gateways/LightDMGateway.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 579 "LightDMGateway.c"
				goto __catch15_g_error;
			}
		}
		goto __finally15;
		__catch15_g_error:
		{
			GError* e = NULL;
			GError* _tmp1_;
			const gchar* _tmp2_;
#line 142 "../src/Gateways/LightDMGateway.vala"
			e = _inner_error_;
#line 142 "../src/Gateways/LightDMGateway.vala"
			_inner_error_ = NULL;
#line 145 "../src/Gateways/LightDMGateway.vala"
			_tmp1_ = e;
#line 145 "../src/Gateways/LightDMGateway.vala"
			_tmp2_ = _tmp1_->message;
#line 145 "../src/Gateways/LightDMGateway.vala"
			g_warning ("LightDMGateway.vala:145: %s", _tmp2_);
#line 142 "../src/Gateways/LightDMGateway.vala"
			_g_error_free0 (e);
#line 601 "LightDMGateway.c"
		}
		__finally15:
#line 142 "../src/Gateways/LightDMGateway.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 142 "../src/Gateways/LightDMGateway.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "../src/Gateways/LightDMGateway.vala"
			g_clear_error (&_inner_error_);
#line 142 "../src/Gateways/LightDMGateway.vala"
			return;
#line 612 "LightDMGateway.c"
		}
	}
}

static void
light_dm_gateway_show_message (LightDMGateway* self,
                               const gchar* text,
                               LightDMMessageType type)
{
	const gchar* _tmp0_;
	GEnumValue* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	MessageText messagetext = 0;
	gboolean _tmp5_ = FALSE;
	MessageText _tmp6_;
	LoginMask* _tmp8_;
	MessageText _tmp9_;
#line 151 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (text != NULL);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = string_to_string (text);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (lightdm_message_type_get_type ()), type);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = string_to_string ((_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_tmp3_ = g_strconcat ("LightDM message: '", _tmp0_, "' (", _tmp2_, ")", NULL);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_tmp4_ = _tmp3_;
#line 152 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:152: %s", _tmp4_);
#line 152 "../src/Gateways/LightDMGateway.vala"
	_g_free0 (_tmp4_);
#line 154 "../src/Gateways/LightDMGateway.vala"
	messagetext = light_dm_gateway_string_to_messagetext (self, text);
#line 156 "../src/Gateways/LightDMGateway.vala"
	_tmp6_ = messagetext;
#line 156 "../src/Gateways/LightDMGateway.vala"
	if (_tmp6_ == MESSAGE_TEXT_FPRINT_SWIPE) {
#line 156 "../src/Gateways/LightDMGateway.vala"
		_tmp5_ = TRUE;
#line 658 "LightDMGateway.c"
	} else {
		MessageText _tmp7_;
#line 156 "../src/Gateways/LightDMGateway.vala"
		_tmp7_ = messagetext;
#line 156 "../src/Gateways/LightDMGateway.vala"
		_tmp5_ = _tmp7_ == MESSAGE_TEXT_FPRINT_PLACE;
#line 665 "LightDMGateway.c"
	}
#line 156 "../src/Gateways/LightDMGateway.vala"
	if (_tmp5_) {
#line 158 "../src/Gateways/LightDMGateway.vala"
		light_dm_gateway_send_prompt (self, PROMPT_TYPE_FPRINT, PROMPT_TEXT_OTHER, "");
#line 671 "LightDMGateway.c"
	}
#line 161 "../src/Gateways/LightDMGateway.vala"
	_tmp8_ = self->priv->_current_login;
#line 161 "../src/Gateways/LightDMGateway.vala"
	_tmp9_ = messagetext;
#line 161 "../src/Gateways/LightDMGateway.vala"
	login_mask_show_message (_tmp8_, type, _tmp9_, text);
#line 679 "LightDMGateway.c"
}

static void
light_dm_gateway_show_prompt (LightDMGateway* self,
                              const gchar* text,
                              LightDMPromptType type)
{
	const gchar* _tmp0_;
	GEnumValue* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 164 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (text != NULL);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = string_to_string (text);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = g_enum_get_value (g_type_class_ref (lightdm_prompt_type_get_type ()), type);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = string_to_string ((_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_tmp3_ = g_strconcat ("LightDM prompt: '", _tmp0_, "' (", _tmp2_, ")", NULL);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_tmp4_ = _tmp3_;
#line 165 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:165: %s", _tmp4_);
#line 165 "../src/Gateways/LightDMGateway.vala"
	_g_free0 (_tmp4_);
#line 167 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_send_prompt (self, light_dm_gateway_lightdm_prompttype_to_prompttype (self, type), light_dm_gateway_string_to_prompttext (self, text), text);
#line 712 "LightDMGateway.c"
}

static void
light_dm_gateway_send_prompt (LightDMGateway* self,
                              PromptType type,
                              PromptText prompttext,
                              const gchar* text)
{
	LoginMask* _tmp0_;
#line 170 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (text != NULL);
#line 171 "../src/Gateways/LightDMGateway.vala"
	self->priv->had_prompt = TRUE;
#line 173 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->_current_login;
#line 173 "../src/Gateways/LightDMGateway.vala"
	login_mask_show_prompt (_tmp0_, type, prompttext, text);
#line 732 "LightDMGateway.c"
}

static PromptType
light_dm_gateway_lightdm_prompttype_to_prompttype (LightDMGateway* self,
                                                   LightDMPromptType type)
{
	PromptType result = 0;
#line 176 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 177 "../src/Gateways/LightDMGateway.vala"
	if (type == LIGHTDM_PROMPT_TYPE_SECRET) {
#line 178 "../src/Gateways/LightDMGateway.vala"
		result = PROMPT_TYPE_SECRET;
#line 178 "../src/Gateways/LightDMGateway.vala"
		return result;
#line 748 "LightDMGateway.c"
	}
#line 181 "../src/Gateways/LightDMGateway.vala"
	result = PROMPT_TYPE_QUESTION;
#line 181 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 754 "LightDMGateway.c"
}

static PromptText
light_dm_gateway_string_to_prompttext (LightDMGateway* self,
                                       const gchar* text)
{
	PromptText result = 0;
#line 184 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 184 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (text != NULL, 0);
#line 185 "../src/Gateways/LightDMGateway.vala"
	if (g_strcmp0 (text, "Password: ") == 0) {
#line 186 "../src/Gateways/LightDMGateway.vala"
		result = PROMPT_TEXT_PASSWORD;
#line 186 "../src/Gateways/LightDMGateway.vala"
		return result;
#line 772 "LightDMGateway.c"
	}
#line 189 "../src/Gateways/LightDMGateway.vala"
	if (g_strcmp0 (text, "login: ") == 0) {
#line 190 "../src/Gateways/LightDMGateway.vala"
		result = PROMPT_TEXT_USERNAME;
#line 190 "../src/Gateways/LightDMGateway.vala"
		return result;
#line 780 "LightDMGateway.c"
	}
#line 193 "../src/Gateways/LightDMGateway.vala"
	result = PROMPT_TEXT_OTHER;
#line 193 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 786 "LightDMGateway.c"
}

static MessageText
light_dm_gateway_string_to_messagetext (LightDMGateway* self,
                                        const gchar* text)
{
	MessageText result = 0;
#line 196 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 196 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (text != NULL, 0);
#line 218 "../src/Gateways/LightDMGateway.vala"
	if (g_strcmp0 (text, g_dgettext ("fprintd", "An unknown error occured")) == 0) {
#line 220 "../src/Gateways/LightDMGateway.vala"
		result = MESSAGE_TEXT_FPRINT_ERROR;
#line 220 "../src/Gateways/LightDMGateway.vala"
		return result;
#line 804 "LightDMGateway.c"
	} else {
#line 221 "../src/Gateways/LightDMGateway.vala"
		if (light_dm_gateway_check_fprintd_string (self, text, "Swipe", "across")) {
#line 223 "../src/Gateways/LightDMGateway.vala"
			result = MESSAGE_TEXT_FPRINT_SWIPE;
#line 223 "../src/Gateways/LightDMGateway.vala"
			return result;
#line 812 "LightDMGateway.c"
		} else {
#line 224 "../src/Gateways/LightDMGateway.vala"
			if (g_strcmp0 (text, g_dgettext ("fprintd", "Swipe your finger again")) == 0) {
#line 226 "../src/Gateways/LightDMGateway.vala"
				result = MESSAGE_TEXT_FPRINT_SWIPE_AGAIN;
#line 226 "../src/Gateways/LightDMGateway.vala"
				return result;
#line 820 "LightDMGateway.c"
			} else {
#line 227 "../src/Gateways/LightDMGateway.vala"
				if (g_strcmp0 (text, g_dgettext ("fprintd", "Swipe was too short, try again")) == 0) {
#line 229 "../src/Gateways/LightDMGateway.vala"
					result = MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT;
#line 229 "../src/Gateways/LightDMGateway.vala"
					return result;
#line 828 "LightDMGateway.c"
				} else {
#line 230 "../src/Gateways/LightDMGateway.vala"
					if (g_strcmp0 (text, g_dgettext ("fprintd", "Your finger was not centered, try swiping your finger again")) == 0) {
#line 232 "../src/Gateways/LightDMGateway.vala"
						result = MESSAGE_TEXT_FPRINT_NOT_CENTERED;
#line 232 "../src/Gateways/LightDMGateway.vala"
						return result;
#line 836 "LightDMGateway.c"
					} else {
#line 233 "../src/Gateways/LightDMGateway.vala"
						if (g_strcmp0 (text, g_dgettext ("fprintd", "Remove your finger, and try swiping your finger again")) == 0) {
#line 235 "../src/Gateways/LightDMGateway.vala"
							result = MESSAGE_TEXT_FPRINT_REMOVE;
#line 235 "../src/Gateways/LightDMGateway.vala"
							return result;
#line 844 "LightDMGateway.c"
						} else {
#line 236 "../src/Gateways/LightDMGateway.vala"
							if (light_dm_gateway_check_fprintd_string (self, text, "Place", "on")) {
#line 238 "../src/Gateways/LightDMGateway.vala"
								result = MESSAGE_TEXT_FPRINT_PLACE;
#line 238 "../src/Gateways/LightDMGateway.vala"
								return result;
#line 852 "LightDMGateway.c"
							} else {
#line 239 "../src/Gateways/LightDMGateway.vala"
								if (g_strcmp0 (text, g_dgettext ("fprintd", "Place your finger on the reader again")) == 0) {
#line 241 "../src/Gateways/LightDMGateway.vala"
									result = MESSAGE_TEXT_FPRINT_PLACE_AGAIN;
#line 241 "../src/Gateways/LightDMGateway.vala"
									return result;
#line 860 "LightDMGateway.c"
								} else {
#line 242 "../src/Gateways/LightDMGateway.vala"
									if (g_strcmp0 (text, g_dgettext ("fprintd", "Failed to match fingerprint")) == 0) {
#line 244 "../src/Gateways/LightDMGateway.vala"
										result = MESSAGE_TEXT_FPRINT_NO_MATCH;
#line 244 "../src/Gateways/LightDMGateway.vala"
										return result;
#line 868 "LightDMGateway.c"
									} else {
#line 245 "../src/Gateways/LightDMGateway.vala"
										if (g_strcmp0 (text, g_dgettext ("fprintd", "Verification timed out")) == 0) {
#line 247 "../src/Gateways/LightDMGateway.vala"
											result = MESSAGE_TEXT_FPRINT_TIMEOUT;
#line 247 "../src/Gateways/LightDMGateway.vala"
											return result;
#line 876 "LightDMGateway.c"
										} else {
#line 248 "../src/Gateways/LightDMGateway.vala"
											if (g_strcmp0 (text, "Login failed") == 0) {
#line 249 "../src/Gateways/LightDMGateway.vala"
												result = MESSAGE_TEXT_FAILED;
#line 249 "../src/Gateways/LightDMGateway.vala"
												return result;
#line 884 "LightDMGateway.c"
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 252 "../src/Gateways/LightDMGateway.vala"
	result = MESSAGE_TEXT_OTHER;
#line 252 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 900 "LightDMGateway.c"
}

gboolean
light_dm_gateway_check_fprintd_string (LightDMGateway* self,
                                       const gchar* text,
                                       const gchar* action,
                                       const gchar* position)
{
	gboolean result = FALSE;
	gchar** fingers = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gint fingers_length1;
	gint _fingers_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
#line 255 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 255 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (action != NULL, FALSE);
#line 255 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = g_strdup ("finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = g_strdup ("left thumb");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = g_strdup ("left index finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp3_ = g_strdup ("left middle finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp4_ = g_strdup ("left ring finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp5_ = g_strdup ("left little finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp6_ = g_strdup ("right thumb");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp7_ = g_strdup ("right index finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp8_ = g_strdup ("right middle finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp9_ = g_strdup ("right ring finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp10_ = g_strdup ("right little finger");
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_ = g_new0 (gchar*, 11 + 1);
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[0] = _tmp0_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[1] = _tmp1_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[2] = _tmp2_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[3] = _tmp3_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[4] = _tmp4_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[5] = _tmp5_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[6] = _tmp6_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[7] = _tmp7_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[8] = _tmp8_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[9] = _tmp9_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_tmp11_[10] = _tmp10_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	fingers = _tmp11_;
#line 256 "../src/Gateways/LightDMGateway.vala"
	fingers_length1 = 11;
#line 256 "../src/Gateways/LightDMGateway.vala"
	_fingers_size_ = fingers_length1;
#line 260 "../src/Gateways/LightDMGateway.vala"
	_tmp12_ = fingers;
#line 260 "../src/Gateways/LightDMGateway.vala"
	_tmp12__length1 = fingers_length1;
#line 991 "LightDMGateway.c"
	{
		gchar** finger_collection = NULL;
		gint finger_collection_length1 = 0;
		gint _finger_collection_size_ = 0;
		gint finger_it = 0;
#line 260 "../src/Gateways/LightDMGateway.vala"
		finger_collection = _tmp12_;
#line 260 "../src/Gateways/LightDMGateway.vala"
		finger_collection_length1 = _tmp12__length1;
#line 260 "../src/Gateways/LightDMGateway.vala"
		for (finger_it = 0; finger_it < _tmp12__length1; finger_it = finger_it + 1) {
#line 1003 "LightDMGateway.c"
			gchar* _tmp13_;
			gchar* finger = NULL;
#line 260 "../src/Gateways/LightDMGateway.vala"
			_tmp13_ = g_strdup (finger_collection[finger_it]);
#line 260 "../src/Gateways/LightDMGateway.vala"
			finger = _tmp13_;
#line 1010 "LightDMGateway.c"
			{
				gchar* english_string = NULL;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gboolean _tmp19_;
#line 261 "../src/Gateways/LightDMGateway.vala"
				_tmp14_ = finger;
#line 261 "../src/Gateways/LightDMGateway.vala"
				_tmp15_ = g_strconcat (action, " your ", _tmp14_, " ", position, " %s", NULL);
#line 261 "../src/Gateways/LightDMGateway.vala"
				english_string = _tmp15_;
#line 264 "../src/Gateways/LightDMGateway.vala"
				_tmp16_ = english_string;
#line 264 "../src/Gateways/LightDMGateway.vala"
				_tmp17_ = g_strdup_printf (g_dgettext ("fprintd", _tmp16_), "");
#line 264 "../src/Gateways/LightDMGateway.vala"
				_tmp18_ = _tmp17_;
#line 264 "../src/Gateways/LightDMGateway.vala"
				_tmp19_ = g_str_has_prefix (text, _tmp18_);
#line 264 "../src/Gateways/LightDMGateway.vala"
				_g_free0 (_tmp18_);
#line 264 "../src/Gateways/LightDMGateway.vala"
				if (_tmp19_) {
#line 265 "../src/Gateways/LightDMGateway.vala"
					result = TRUE;
#line 265 "../src/Gateways/LightDMGateway.vala"
					_g_free0 (english_string);
#line 265 "../src/Gateways/LightDMGateway.vala"
					_g_free0 (finger);
#line 265 "../src/Gateways/LightDMGateway.vala"
					fingers = (_vala_array_free (fingers, fingers_length1, (GDestroyNotify) g_free), NULL);
#line 265 "../src/Gateways/LightDMGateway.vala"
					return result;
#line 1047 "LightDMGateway.c"
				}
#line 260 "../src/Gateways/LightDMGateway.vala"
				_g_free0 (english_string);
#line 260 "../src/Gateways/LightDMGateway.vala"
				_g_free0 (finger);
#line 1053 "LightDMGateway.c"
			}
		}
	}
#line 270 "../src/Gateways/LightDMGateway.vala"
	result = FALSE;
#line 270 "../src/Gateways/LightDMGateway.vala"
	fingers = (_vala_array_free (fingers, fingers_length1, (GDestroyNotify) g_free), NULL);
#line 270 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1063 "LightDMGateway.c"
}

static void
light_dm_gateway_real_start_session (LoginGateway* base)
{
	LightDMGateway * self;
	LoginMask* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	PantheonGreeter* _tmp6_;
	PantheonGreeter* _tmp7_;
	LoginMask* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	GError * _inner_error_ = NULL;
#line 273 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 274 "../src/Gateways/LightDMGateway.vala"
	if (!self->priv->awaiting_start_session) {
#line 275 "../src/Gateways/LightDMGateway.vala"
		g_warning ("LightDMGateway.vala:275: Got start_session without awaiting it.");
#line 1088 "LightDMGateway.c"
	}
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->_current_login;
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = login_mask_get_login_session (_tmp0_);
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp4_ = g_strconcat ("Starting session ", _tmp3_, NULL);
#line 277 "../src/Gateways/LightDMGateway.vala"
	_tmp5_ = _tmp4_;
#line 277 "../src/Gateways/LightDMGateway.vala"
	g_message ("LightDMGateway.vala:277: %s", _tmp5_);
#line 277 "../src/Gateways/LightDMGateway.vala"
	_g_free0 (_tmp5_);
#line 278 "../src/Gateways/LightDMGateway.vala"
	_tmp6_ = pantheon_greeter_get_instance ();
#line 278 "../src/Gateways/LightDMGateway.vala"
	_tmp7_ = _tmp6_;
#line 278 "../src/Gateways/LightDMGateway.vala"
	_tmp8_ = self->priv->_current_login;
#line 278 "../src/Gateways/LightDMGateway.vala"
	_tmp9_ = login_mask_get_login_name (_tmp8_);
#line 278 "../src/Gateways/LightDMGateway.vala"
	_tmp10_ = _tmp9_;
#line 278 "../src/Gateways/LightDMGateway.vala"
	pantheon_greeter_set_greeter_state (_tmp7_, "last-user", _tmp10_);
#line 1118 "LightDMGateway.c"
	{
		LightDMGreeter* _tmp11_;
		LoginMask* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 281 "../src/Gateways/LightDMGateway.vala"
		_tmp11_ = self->priv->lightdm;
#line 281 "../src/Gateways/LightDMGateway.vala"
		_tmp12_ = self->priv->_current_login;
#line 281 "../src/Gateways/LightDMGateway.vala"
		_tmp13_ = login_mask_get_login_session (_tmp12_);
#line 281 "../src/Gateways/LightDMGateway.vala"
		_tmp14_ = _tmp13_;
#line 281 "../src/Gateways/LightDMGateway.vala"
		lightdm_greeter_start_session_sync (_tmp11_, _tmp14_, &_inner_error_);
#line 281 "../src/Gateways/LightDMGateway.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1136 "LightDMGateway.c"
			goto __catch16_g_error;
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
#line 280 "../src/Gateways/LightDMGateway.vala"
		e = _inner_error_;
#line 280 "../src/Gateways/LightDMGateway.vala"
		_inner_error_ = NULL;
#line 283 "../src/Gateways/LightDMGateway.vala"
		_tmp15_ = e->message;
#line 283 "../src/Gateways/LightDMGateway.vala"
		g_error ("LightDMGateway.vala:283: %s", _tmp15_);
#line 280 "../src/Gateways/LightDMGateway.vala"
		_g_error_free0 (e);
#line 1155 "LightDMGateway.c"
	}
	__finally16:
#line 280 "../src/Gateways/LightDMGateway.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 280 "../src/Gateways/LightDMGateway.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 280 "../src/Gateways/LightDMGateway.vala"
		g_clear_error (&_inner_error_);
#line 280 "../src/Gateways/LightDMGateway.vala"
		return;
#line 1166 "LightDMGateway.c"
	}
}

static void
light_dm_gateway_authentication (LightDMGateway* self)
{
	LightDMGreeter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 287 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 288 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_is_authenticated (_tmp0_);
#line 288 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 288 "../src/Gateways/LightDMGateway.vala"
	if (_tmp2_) {
#line 291 "../src/Gateways/LightDMGateway.vala"
		if (self->priv->had_prompt) {
#line 293 "../src/Gateways/LightDMGateway.vala"
			self->priv->awaiting_start_session = TRUE;
#line 294 "../src/Gateways/LightDMGateway.vala"
			g_signal_emit_by_name ((LoginGateway*) self, "login-successful");
#line 1192 "LightDMGateway.c"
		} else {
			LoginMask* _tmp3_;
#line 296 "../src/Gateways/LightDMGateway.vala"
			g_message ("LightDMGateway.vala:296: %s", "Auth complete, but we await user-interaction before we" "start a session");
#line 300 "../src/Gateways/LightDMGateway.vala"
			self->priv->awaiting_confirmation = TRUE;
#line 301 "../src/Gateways/LightDMGateway.vala"
			_tmp3_ = self->priv->_current_login;
#line 301 "../src/Gateways/LightDMGateway.vala"
			login_mask_show_prompt (_tmp3_, PROMPT_TYPE_CONFIRM_LOGIN, PROMPT_TEXT_OTHER, "");
#line 1203 "LightDMGateway.c"
		}
	} else {
		LoginMask* _tmp4_;
#line 304 "../src/Gateways/LightDMGateway.vala"
		_tmp4_ = self->priv->_current_login;
#line 304 "../src/Gateways/LightDMGateway.vala"
		login_mask_not_authenticated (_tmp4_);
#line 1211 "LightDMGateway.c"
	}
}

static LoginMask*
light_dm_gateway_get_current_login (LightDMGateway* self)
{
	LoginMask* result;
	LoginMask* _tmp0_;
#line 30 "../src/Gateways/LightDMGateway.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->_current_login;
#line 30 "../src/Gateways/LightDMGateway.vala"
	result = _tmp0_;
#line 30 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1228 "LightDMGateway.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/Gateways/LightDMGateway.vala"
	return self ? g_object_ref (self) : NULL;
#line 1236 "LightDMGateway.c"
}

static void
light_dm_gateway_set_current_login (LightDMGateway* self,
                                    LoginMask* value)
{
	LoginMask* _tmp0_;
#line 30 "../src/Gateways/LightDMGateway.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/Gateways/LightDMGateway.vala"
	_g_object_unref0 (self->priv->_current_login);
#line 30 "../src/Gateways/LightDMGateway.vala"
	self->priv->_current_login = _tmp0_;
#line 1252 "LightDMGateway.c"
}

static gboolean
light_dm_gateway_real_get_hide_users (LoginGateway* base)
{
	gboolean result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 53 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 54 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 54 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_hide_users_hint (_tmp0_);
#line 54 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 54 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1275 "LightDMGateway.c"
}

static gboolean
light_dm_gateway_real_get_has_guest_account (LoginGateway* base)
{
	gboolean result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 58 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 59 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 59 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_has_guest_account_hint (_tmp0_);
#line 59 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 59 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1298 "LightDMGateway.c"
}

static gboolean
light_dm_gateway_real_get_show_manual_login (LoginGateway* base)
{
	gboolean result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 63 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 64 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 64 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_show_manual_login_hint (_tmp0_);
#line 64 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 64 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1321 "LightDMGateway.c"
}

static gboolean
light_dm_gateway_real_get_lock (LoginGateway* base)
{
	gboolean result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 68 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 69 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 69 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_lock_hint (_tmp0_);
#line 69 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 69 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 69 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1344 "LightDMGateway.c"
}

static const gchar*
light_dm_gateway_real_get_default_session (LoginGateway* base)
{
	const gchar* result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 73 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 74 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 74 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_default_session_hint (_tmp0_);
#line 74 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 74 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 74 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1367 "LightDMGateway.c"
}

static const gchar*
light_dm_gateway_real_get_select_user (LoginGateway* base)
{
	const gchar* result;
	LightDMGateway* self;
	LightDMGreeter* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 78 "../src/Gateways/LightDMGateway.vala"
	self = (LightDMGateway*) base;
#line 79 "../src/Gateways/LightDMGateway.vala"
	_tmp0_ = self->priv->lightdm;
#line 79 "../src/Gateways/LightDMGateway.vala"
	_tmp1_ = lightdm_greeter_get_select_user_hint (_tmp0_);
#line 79 "../src/Gateways/LightDMGateway.vala"
	_tmp2_ = _tmp1_;
#line 79 "../src/Gateways/LightDMGateway.vala"
	result = _tmp2_;
#line 79 "../src/Gateways/LightDMGateway.vala"
	return result;
#line 1390 "LightDMGateway.c"
}

static void
light_dm_gateway_class_init (LightDMGatewayClass * klass,
                             gpointer klass_data)
{
#line 24 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_type_class_adjust_private_offset (klass, &LightDMGateway_private_offset);
#line 24 "../src/Gateways/LightDMGateway.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_light_dm_gateway_get_property;
#line 24 "../src/Gateways/LightDMGateway.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_light_dm_gateway_set_property;
#line 24 "../src/Gateways/LightDMGateway.vala"
	G_OBJECT_CLASS (klass)->finalize = light_dm_gateway_finalize;
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_HIDE_USERS_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_HIDE_USERS_PROPERTY] = g_param_spec_boolean ("hide-users", "hide-users", "hide-users", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY] = g_param_spec_boolean ("has-guest-account", "has-guest-account", "has-guest-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY] = g_param_spec_boolean ("show-manual-login", "show-manual-login", "show-manual-login", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_LOCK_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_LOCK_PROPERTY] = g_param_spec_boolean ("lock", "lock", "lock", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_DEFAULT_SESSION_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_DEFAULT_SESSION_PROPERTY] = g_param_spec_string ("default-session", "default-session", "default-session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/Gateways/LightDMGateway.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LIGHT_DM_GATEWAY_SELECT_USER_PROPERTY, light_dm_gateway_properties[LIGHT_DM_GATEWAY_SELECT_USER_PROPERTY] = g_param_spec_string ("select-user", "select-user", "select-user", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1419 "LightDMGateway.c"
}

static void
light_dm_gateway_login_gateway_interface_init (LoginGatewayIface * iface,
                                               gpointer iface_data)
{
#line 24 "../src/Gateways/LightDMGateway.vala"
	light_dm_gateway_login_gateway_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->login_with_mask = (void (*) (LoginGateway*, LoginMask*, gboolean)) light_dm_gateway_real_login_with_mask;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->respond = (void (*) (LoginGateway*, const gchar*)) light_dm_gateway_real_respond;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->start_session = (void (*) (LoginGateway*)) light_dm_gateway_real_start_session;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_hide_users = light_dm_gateway_real_get_hide_users;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_has_guest_account = light_dm_gateway_real_get_has_guest_account;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_show_manual_login = light_dm_gateway_real_get_show_manual_login;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_lock = light_dm_gateway_real_get_lock;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_default_session = light_dm_gateway_real_get_default_session;
#line 24 "../src/Gateways/LightDMGateway.vala"
	iface->get_select_user = light_dm_gateway_real_get_select_user;
#line 1446 "LightDMGateway.c"
}

static void
light_dm_gateway_instance_init (LightDMGateway * self,
                                gpointer klass)
{
#line 24 "../src/Gateways/LightDMGateway.vala"
	self->priv = light_dm_gateway_get_instance_private (self);
#line 30 "../src/Gateways/LightDMGateway.vala"
	self->priv->_current_login = NULL;
#line 39 "../src/Gateways/LightDMGateway.vala"
	self->priv->had_prompt = FALSE;
#line 46 "../src/Gateways/LightDMGateway.vala"
	self->priv->awaiting_confirmation = FALSE;
#line 48 "../src/Gateways/LightDMGateway.vala"
	self->priv->awaiting_start_session = FALSE;
#line 1463 "LightDMGateway.c"
}

static void
light_dm_gateway_finalize (GObject * obj)
{
	LightDMGateway * self;
#line 24 "../src/Gateways/LightDMGateway.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIGHT_DM_GATEWAY, LightDMGateway);
#line 30 "../src/Gateways/LightDMGateway.vala"
	_g_object_unref0 (self->priv->_current_login);
#line 50 "../src/Gateways/LightDMGateway.vala"
	_g_object_unref0 (self->priv->lightdm);
#line 24 "../src/Gateways/LightDMGateway.vala"
	G_OBJECT_CLASS (light_dm_gateway_parent_class)->finalize (obj);
#line 1478 "LightDMGateway.c"
}

/**
 * Passes communication to LightDM.
 */
GType
light_dm_gateway_get_type (void)
{
	static volatile gsize light_dm_gateway_type_id__volatile = 0;
	if (g_once_init_enter (&light_dm_gateway_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LightDMGatewayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) light_dm_gateway_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LightDMGateway), 0, (GInstanceInitFunc) light_dm_gateway_instance_init, NULL };
		static const GInterfaceInfo login_gateway_info = { (GInterfaceInitFunc) light_dm_gateway_login_gateway_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType light_dm_gateway_type_id;
		light_dm_gateway_type_id = g_type_register_static (G_TYPE_OBJECT, "LightDMGateway", &g_define_type_info, 0);
		g_type_add_interface_static (light_dm_gateway_type_id, TYPE_LOGIN_GATEWAY, &login_gateway_info);
		LightDMGateway_private_offset = g_type_add_instance_private (light_dm_gateway_type_id, sizeof (LightDMGatewayPrivate));
		g_once_init_leave (&light_dm_gateway_type_id__volatile, light_dm_gateway_type_id);
	}
	return light_dm_gateway_type_id__volatile;
}

static void
_vala_light_dm_gateway_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	LightDMGateway * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIGHT_DM_GATEWAY, LightDMGateway);
#line 24 "../src/Gateways/LightDMGateway.vala"
	switch (property_id) {
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_HIDE_USERS_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_boolean (value, login_gateway_get_hide_users ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_HAS_GUEST_ACCOUNT_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_boolean (value, login_gateway_get_has_guest_account ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_SHOW_MANUAL_LOGIN_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_boolean (value, login_gateway_get_show_manual_login ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_LOCK_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_boolean (value, login_gateway_get_lock ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_DEFAULT_SESSION_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_string (value, login_gateway_get_default_session ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 24 "../src/Gateways/LightDMGateway.vala"
		case LIGHT_DM_GATEWAY_SELECT_USER_PROPERTY:
#line 24 "../src/Gateways/LightDMGateway.vala"
		g_value_set_string (value, login_gateway_get_select_user ((LoginGateway*) self));
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 1546 "LightDMGateway.c"
		default:
#line 24 "../src/Gateways/LightDMGateway.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 1552 "LightDMGateway.c"
	}
}

static void
_vala_light_dm_gateway_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	LightDMGateway * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LIGHT_DM_GATEWAY, LightDMGateway);
#line 24 "../src/Gateways/LightDMGateway.vala"
	switch (property_id) {
#line 1566 "LightDMGateway.c"
		default:
#line 24 "../src/Gateways/LightDMGateway.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Gateways/LightDMGateway.vala"
		break;
#line 1572 "LightDMGateway.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

