/* LoginGateway.c generated by valac 0.43.6, the Vala compiler
 * generated from LoginGateway.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;
typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())
typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())
typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())
enum  {
	LOGIN_GATEWAY_LOGIN_SUCCESSFUL_SIGNAL,
	LOGIN_GATEWAY_NUM_SIGNALS
};
static guint login_gateway_signals[LOGIN_GATEWAY_NUM_SIGNALS] = {0};

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
void login_gateway_login_with_mask (LoginGateway* self,
                                    LoginMask* mask,
                                    gboolean guest);
void login_gateway_respond (LoginGateway* self,
                            const gchar* message);
void login_gateway_start_session (LoginGateway* self);
gboolean login_gateway_get_hide_users (LoginGateway* self);
gboolean login_gateway_get_has_guest_account (LoginGateway* self);
gboolean login_gateway_get_show_manual_login (LoginGateway* self);
gboolean login_gateway_get_lock (LoginGateway* self);
const gchar* login_gateway_get_default_session (LoginGateway* self);
const gchar* login_gateway_get_select_user (LoginGateway* self);

/**
     * Starts the login-procedure for the passed
     */
void
login_gateway_login_with_mask (LoginGateway* self,
                               LoginMask* mask,
                               gboolean guest)
{
#line 33 "../src/Gateways/LoginGateway.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Gateways/LoginGateway.vala"
	LOGIN_GATEWAY_GET_INTERFACE (self)->login_with_mask (self, mask, guest);
#line 136 "LoginGateway.c"
}

void
login_gateway_respond (LoginGateway* self,
                       const gchar* message)
{
#line 35 "../src/Gateways/LoginGateway.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Gateways/LoginGateway.vala"
	LOGIN_GATEWAY_GET_INTERFACE (self)->respond (self, message);
#line 147 "LoginGateway.c"
}

/**
     * Only to be called after the login_successful was fired.
     * Will start the session and exits this process.
     */
void
login_gateway_start_session (LoginGateway* self)
{
#line 49 "../src/Gateways/LoginGateway.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Gateways/LoginGateway.vala"
	LOGIN_GATEWAY_GET_INTERFACE (self)->start_session (self);
#line 161 "LoginGateway.c"
}

gboolean
login_gateway_get_hide_users (LoginGateway* self)
{
#line 23 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_hide_users (self);
#line 171 "LoginGateway.c"
}

gboolean
login_gateway_get_has_guest_account (LoginGateway* self)
{
#line 24 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_has_guest_account (self);
#line 181 "LoginGateway.c"
}

gboolean
login_gateway_get_show_manual_login (LoginGateway* self)
{
#line 25 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_show_manual_login (self);
#line 191 "LoginGateway.c"
}

gboolean
login_gateway_get_lock (LoginGateway* self)
{
#line 26 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_lock (self);
#line 201 "LoginGateway.c"
}

const gchar*
login_gateway_get_default_session (LoginGateway* self)
{
#line 27 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_default_session (self);
#line 211 "LoginGateway.c"
}

const gchar*
login_gateway_get_select_user (LoginGateway* self)
{
#line 28 "../src/Gateways/LoginGateway.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Gateways/LoginGateway.vala"
	return LOGIN_GATEWAY_GET_INTERFACE (self)->get_select_user (self);
#line 221 "LoginGateway.c"
}

static void
login_gateway_default_init (LoginGatewayIface * iface,
                            gpointer iface_data)
{
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("hide-users", "hide-users", "hide-users", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("has-guest-account", "has-guest-account", "has-guest-account", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("show-manual-login", "show-manual-login", "show-manual-login", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("lock", "lock", "lock", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("default-session", "default-session", "default-session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/Gateways/LoginGateway.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("select-user", "select-user", "select-user", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 240 "LoginGateway.c"
	/**
	     * Called when a user successfully logins. It gives the Greeter time
	     * to run fade out animations etc.
	     * The Gateway shall not accept any request from now on beside
	     * the start_session call.
	     */
#line 21 "../src/Gateways/LoginGateway.vala"
	login_gateway_signals[LOGIN_GATEWAY_LOGIN_SUCCESSFUL_SIGNAL] = g_signal_new ("login-successful", TYPE_LOGIN_GATEWAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 249 "LoginGateway.c"
}

GType
login_gateway_get_type (void)
{
	static volatile gsize login_gateway_type_id__volatile = 0;
	if (g_once_init_enter (&login_gateway_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LoginGatewayIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_gateway_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType login_gateway_type_id;
		login_gateway_type_id = g_type_register_static (G_TYPE_INTERFACE, "LoginGateway", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (login_gateway_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&login_gateway_type_id__volatile, login_gateway_type_id);
	}
	return login_gateway_type_id__volatile;
}

