/* LoginOption.c generated by valac 0.43.6, the Vala compiler
 * generated from LoginOption.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC. (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>

#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;
enum  {
	LOGIN_OPTION_0_PROPERTY,
	LOGIN_OPTION_INDEX_PROPERTY,
	LOGIN_OPTION_DISPLAY_NAME_PROPERTY,
	LOGIN_OPTION_AVATAR_PATH_PROPERTY,
	LOGIN_OPTION_BACKGROUND_PROPERTY,
	LOGIN_OPTION_NAME_PROPERTY,
	LOGIN_OPTION_LOGGED_IN_PROPERTY,
	LOGIN_OPTION_IS_GUEST_PROPERTY,
	LOGIN_OPTION_PROVIDES_LOGIN_NAME_PROPERTY,
	LOGIN_OPTION_SESSION_PROPERTY,
	LOGIN_OPTION_NUM_PROPERTIES
};
static GParamSpec* login_option_properties[LOGIN_OPTION_NUM_PROPERTIES];

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;
typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())
typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())
typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _LoginOptionPrivate {
	gint _index;
};

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

static gint LoginOption_private_offset;
static gpointer login_option_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
LoginOption* login_option_construct (GType object_type,
                                     gint index);
static void login_option_set_index (LoginOption* self,
                             gint value);
gchar* login_option_get_markup (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
gint login_option_get_index (LoginOption* self);
const gchar* login_option_get_avatar_path (LoginOption* self);
const gchar* login_option_get_background (LoginOption* self);
const gchar* login_option_get_name (LoginOption* self);
gboolean login_option_get_logged_in (LoginOption* self);
gboolean login_option_get_is_guest (LoginOption* self);
gboolean login_option_get_provides_login_name (LoginOption* self);
const gchar* login_option_get_session (LoginOption* self);
GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_gateway_get_type (void) G_GNUC_CONST;
LoginGateway* pantheon_greeter_get_login_gateway (void);
const gchar* login_gateway_get_default_session (LoginGateway* self);
static void login_option_finalize (GObject * obj);
static void _vala_login_option_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_login_option_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
login_option_get_instance_private (LoginOption* self)
{
	return G_STRUCT_MEMBER_P (self, LoginOption_private_offset);
}

LoginOption*
login_option_construct (GType object_type,
                        gint index)
{
	LoginOption * self = NULL;
#line 24 "../src/LoginOptions/LoginOption.vala"
	self = (LoginOption*) g_object_new (object_type, NULL);
#line 25 "../src/LoginOptions/LoginOption.vala"
	login_option_set_index (self, index);
#line 24 "../src/LoginOptions/LoginOption.vala"
	return self;
#line 199 "LoginOption.c"
}

gchar*
login_option_get_markup (LoginOption* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 28 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/LoginOptions/LoginOption.vala"
	_tmp0_ = login_option_get_display_name (self);
#line 29 "../src/LoginOptions/LoginOption.vala"
	_tmp1_ = _tmp0_;
#line 29 "../src/LoginOptions/LoginOption.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 29 "../src/LoginOptions/LoginOption.vala"
	result = _tmp2_;
#line 29 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 221 "LoginOption.c"
}

gint
login_option_get_index (LoginOption* self)
{
	gint result;
#line 22 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 22 "../src/LoginOptions/LoginOption.vala"
	result = self->priv->_index;
#line 22 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 234 "LoginOption.c"
}

static void
login_option_set_index (LoginOption* self,
                        gint value)
{
#line 22 "../src/LoginOptions/LoginOption.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/LoginOptions/LoginOption.vala"
	if (login_option_get_index (self) != value) {
#line 22 "../src/LoginOptions/LoginOption.vala"
		self->priv->_index = value;
#line 22 "../src/LoginOptions/LoginOption.vala"
		g_object_notify_by_pspec ((GObject *) self, login_option_properties[LOGIN_OPTION_INDEX_PROPERTY]);
#line 249 "LoginOption.c"
	}
}

const gchar*
login_option_get_display_name (LoginOption* self)
{
#line 35 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_display_name (self);
#line 260 "LoginOption.c"
}

const gchar*
login_option_get_avatar_path (LoginOption* self)
{
#line 42 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_avatar_path (self);
#line 270 "LoginOption.c"
}

static const gchar*
login_option_real_get_avatar_path (LoginOption* base)
{
	const gchar* result;
	LoginOption* self;
#line 42 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 43 "../src/LoginOptions/LoginOption.vala"
	result = NULL;
#line 43 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 284 "LoginOption.c"
}

const gchar*
login_option_get_background (LoginOption* self)
{
#line 52 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_background (self);
#line 294 "LoginOption.c"
}

static const gchar*
login_option_real_get_background (LoginOption* base)
{
	const gchar* result;
	LoginOption* self;
#line 52 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 53 "../src/LoginOptions/LoginOption.vala"
	result = "";
#line 53 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 308 "LoginOption.c"
}

const gchar*
login_option_get_name (LoginOption* self)
{
#line 63 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_name (self);
#line 318 "LoginOption.c"
}

gboolean
login_option_get_logged_in (LoginOption* self)
{
#line 69 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_logged_in (self);
#line 328 "LoginOption.c"
}

static gboolean
login_option_real_get_logged_in (LoginOption* base)
{
	gboolean result;
	LoginOption* self;
#line 69 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 70 "../src/LoginOptions/LoginOption.vala"
	result = FALSE;
#line 70 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 342 "LoginOption.c"
}

gboolean
login_option_get_is_guest (LoginOption* self)
{
#line 79 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 79 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_is_guest (self);
#line 352 "LoginOption.c"
}

static gboolean
login_option_real_get_is_guest (LoginOption* base)
{
	gboolean result;
	LoginOption* self;
#line 79 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 80 "../src/LoginOptions/LoginOption.vala"
	result = FALSE;
#line 80 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 366 "LoginOption.c"
}

gboolean
login_option_get_provides_login_name (LoginOption* self)
{
#line 90 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_provides_login_name (self);
#line 376 "LoginOption.c"
}

static gboolean
login_option_real_get_provides_login_name (LoginOption* base)
{
	gboolean result;
	LoginOption* self;
#line 90 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 91 "../src/LoginOptions/LoginOption.vala"
	result = TRUE;
#line 91 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 390 "LoginOption.c"
}

const gchar*
login_option_get_session (LoginOption* self)
{
#line 99 "../src/LoginOptions/LoginOption.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/LoginOptions/LoginOption.vala"
	return LOGIN_OPTION_GET_CLASS (self)->get_session (self);
#line 400 "LoginOption.c"
}

static const gchar*
login_option_real_get_session (LoginOption* base)
{
	const gchar* result;
	LoginOption* self;
	LoginGateway* _tmp0_;
	LoginGateway* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 99 "../src/LoginOptions/LoginOption.vala"
	self = base;
#line 100 "../src/LoginOptions/LoginOption.vala"
	_tmp0_ = pantheon_greeter_get_login_gateway ();
#line 100 "../src/LoginOptions/LoginOption.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/LoginOptions/LoginOption.vala"
	_tmp2_ = login_gateway_get_default_session (_tmp1_);
#line 100 "../src/LoginOptions/LoginOption.vala"
	_tmp3_ = _tmp2_;
#line 100 "../src/LoginOptions/LoginOption.vala"
	result = _tmp3_;
#line 100 "../src/LoginOptions/LoginOption.vala"
	return result;
#line 426 "LoginOption.c"
}

static void
login_option_class_init (LoginOptionClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/LoginOptions/LoginOption.vala"
	login_option_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_type_class_adjust_private_offset (klass, &LoginOption_private_offset);
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_avatar_path = login_option_real_get_avatar_path;
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_background = login_option_real_get_background;
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_logged_in = login_option_real_get_logged_in;
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_is_guest = login_option_real_get_is_guest;
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_provides_login_name = login_option_real_get_provides_login_name;
#line 21 "../src/LoginOptions/LoginOption.vala"
	LOGIN_OPTION_CLASS (klass)->get_session = login_option_real_get_session;
#line 21 "../src/LoginOptions/LoginOption.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_login_option_get_property;
#line 21 "../src/LoginOptions/LoginOption.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_login_option_set_property;
#line 21 "../src/LoginOptions/LoginOption.vala"
	G_OBJECT_CLASS (klass)->finalize = login_option_finalize;
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_INDEX_PROPERTY, login_option_properties[LOGIN_OPTION_INDEX_PROPERTY] = g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 457 "LoginOption.c"
	/**
	     * The name of this login how it shall be presented to the user.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_DISPLAY_NAME_PROPERTY, login_option_properties[LOGIN_OPTION_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 463 "LoginOption.c"
	/**
	     * Path to the avatar of this user or null
	     * in case he has none.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_AVATAR_PATH_PROPERTY, login_option_properties[LOGIN_OPTION_AVATAR_PATH_PROPERTY] = g_param_spec_string ("avatar-path", "avatar-path", "avatar-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 470 "LoginOption.c"
	/**
	     * Path to the background-image of this user or ""
	     * in case he has none.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_BACKGROUND_PROPERTY, login_option_properties[LOGIN_OPTION_BACKGROUND_PROPERTY] = g_param_spec_string ("background", "background", "background", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 477 "LoginOption.c"
	/**
	     * The login name for this LoginOption. This is also used to identify this object
	     * from one session to another. Note that you still have to return a unique
	     * string even if this LoginOption cannot directly provide a login name to
	     * identify this entry.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_NAME_PROPERTY, login_option_properties[LOGIN_OPTION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 486 "LoginOption.c"
	/**
	     * True if and only if this user is currently logged in.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_LOGGED_IN_PROPERTY, login_option_properties[LOGIN_OPTION_LOGGED_IN_PROPERTY] = g_param_spec_boolean ("logged-in", "logged-in", "logged-in", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 492 "LoginOption.c"
	/**
	     * If this LoginOption is for a guest-user. This is necessary
	     * as LightDM handles guests in a special way.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_IS_GUEST_PROPERTY, login_option_properties[LOGIN_OPTION_IS_GUEST_PROPERTY] = g_param_spec_boolean ("is-guest", "is-guest", "is-guest", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 499 "LoginOption.c"
	/**
	     * True if this LoginOption provides the necessary information to determine
	     * the login name. This is for example used by the LoginBox to decide if
	     * a Entry for a login name is necessary or not.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_PROVIDES_LOGIN_NAME_PROPERTY, login_option_properties[LOGIN_OPTION_PROVIDES_LOGIN_NAME_PROPERTY] = g_param_spec_boolean ("provides-login-name", "provides-login-name", "provides-login-name", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 507 "LoginOption.c"
	/**
	     * The name of the session that this user wants by default.
	     */
#line 21 "../src/LoginOptions/LoginOption.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_OPTION_SESSION_PROPERTY, login_option_properties[LOGIN_OPTION_SESSION_PROPERTY] = g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 513 "LoginOption.c"
}

static void
login_option_instance_init (LoginOption * self,
                            gpointer klass)
{
#line 21 "../src/LoginOptions/LoginOption.vala"
	self->priv = login_option_get_instance_private (self);
#line 522 "LoginOption.c"
}

static void
login_option_finalize (GObject * obj)
{
	LoginOption * self;
#line 21 "../src/LoginOptions/LoginOption.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOGIN_OPTION, LoginOption);
#line 21 "../src/LoginOptions/LoginOption.vala"
	G_OBJECT_CLASS (login_option_parent_class)->finalize (obj);
#line 533 "LoginOption.c"
}

GType
login_option_get_type (void)
{
	static volatile gsize login_option_type_id__volatile = 0;
	if (g_once_init_enter (&login_option_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LoginOptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_option_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LoginOption), 0, (GInstanceInitFunc) login_option_instance_init, NULL };
		GType login_option_type_id;
		login_option_type_id = g_type_register_static (G_TYPE_OBJECT, "LoginOption", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		LoginOption_private_offset = g_type_add_instance_private (login_option_type_id, sizeof (LoginOptionPrivate));
		g_once_init_leave (&login_option_type_id__volatile, login_option_type_id);
	}
	return login_option_type_id__volatile;
}

static void
_vala_login_option_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	LoginOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_OPTION, LoginOption);
#line 21 "../src/LoginOptions/LoginOption.vala"
	switch (property_id) {
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_INDEX_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_int (value, login_option_get_index (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_AVATAR_PATH_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_string (value, login_option_get_avatar_path (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_BACKGROUND_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_string (value, login_option_get_background (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_LOGGED_IN_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_boolean (value, login_option_get_logged_in (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_IS_GUEST_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_boolean (value, login_option_get_is_guest (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_PROVIDES_LOGIN_NAME_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_boolean (value, login_option_get_provides_login_name (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_SESSION_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		g_value_set_string (value, login_option_get_session (self));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 602 "LoginOption.c"
		default:
#line 21 "../src/LoginOptions/LoginOption.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 608 "LoginOption.c"
	}
}

static void
_vala_login_option_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	LoginOption * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_OPTION, LoginOption);
#line 21 "../src/LoginOptions/LoginOption.vala"
	switch (property_id) {
#line 21 "../src/LoginOptions/LoginOption.vala"
		case LOGIN_OPTION_INDEX_PROPERTY:
#line 21 "../src/LoginOptions/LoginOption.vala"
		login_option_set_index (self, g_value_get_int (value));
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 628 "LoginOption.c"
		default:
#line 21 "../src/LoginOptions/LoginOption.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/LoginOptions/LoginOption.vala"
		break;
#line 634 "LoginOption.c"
	}
}

