/* ManualLogin.c generated by valac 0.43.6, the Vala compiler
 * generated from ManualLogin.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;

#define TYPE_MANUAL_LOGIN (manual_login_get_type ())
#define MANUAL_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MANUAL_LOGIN, ManualLogin))
#define MANUAL_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MANUAL_LOGIN, ManualLoginClass))
#define IS_MANUAL_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MANUAL_LOGIN))
#define IS_MANUAL_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MANUAL_LOGIN))
#define MANUAL_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MANUAL_LOGIN, ManualLoginClass))

typedef struct _ManualLogin ManualLogin;
typedef struct _ManualLoginClass ManualLoginClass;
typedef struct _ManualLoginPrivate ManualLoginPrivate;
enum  {
	MANUAL_LOGIN_0_PROPERTY,
	MANUAL_LOGIN_NAME_PROPERTY,
	MANUAL_LOGIN_DISPLAY_NAME_PROPERTY,
	MANUAL_LOGIN_PROVIDES_LOGIN_NAME_PROPERTY,
	MANUAL_LOGIN_NUM_PROPERTIES
};
static GParamSpec* manual_login_properties[MANUAL_LOGIN_NUM_PROPERTIES];

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _ManualLogin {
	LoginOption parent_instance;
	ManualLoginPrivate * priv;
};

struct _ManualLoginClass {
	LoginOptionClass parent_class;
};

static gpointer manual_login_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
GType manual_login_get_type (void) G_GNUC_CONST;
ManualLogin* manual_login_new (gint index);
ManualLogin* manual_login_construct (GType object_type,
                                     gint index);
LoginOption* login_option_construct (GType object_type,
                                     gint index);
const gchar* login_option_get_name (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
gboolean login_option_get_provides_login_name (LoginOption* self);
static void _vala_manual_login_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);

ManualLogin*
manual_login_construct (GType object_type,
                        gint index)
{
	ManualLogin * self = NULL;
#line 24 "../src/LoginOptions/ManualLogin.vala"
	self = (ManualLogin*) login_option_construct (object_type, index);
#line 23 "../src/LoginOptions/ManualLogin.vala"
	return self;
#line 113 "ManualLogin.c"
}

ManualLogin*
manual_login_new (gint index)
{
#line 23 "../src/LoginOptions/ManualLogin.vala"
	return manual_login_construct (TYPE_MANUAL_LOGIN, index);
#line 121 "ManualLogin.c"
}

static const gchar*
manual_login_real_get_name (LoginOption* base)
{
	const gchar* result;
	ManualLogin* self;
#line 28 "../src/LoginOptions/ManualLogin.vala"
	self = (ManualLogin*) base;
#line 29 "../src/LoginOptions/ManualLogin.vala"
	result = "?pantheon greeter manual?";
#line 29 "../src/LoginOptions/ManualLogin.vala"
	return result;
#line 135 "ManualLogin.c"
}

static const gchar*
manual_login_real_get_display_name (LoginOption* base)
{
	const gchar* result;
	ManualLogin* self;
#line 34 "../src/LoginOptions/ManualLogin.vala"
	self = (ManualLogin*) base;
#line 35 "../src/LoginOptions/ManualLogin.vala"
	result = _ ("Manual Login");
#line 35 "../src/LoginOptions/ManualLogin.vala"
	return result;
#line 149 "ManualLogin.c"
}

static gboolean
manual_login_real_get_provides_login_name (LoginOption* base)
{
	gboolean result;
	ManualLogin* self;
#line 41 "../src/LoginOptions/ManualLogin.vala"
	self = (ManualLogin*) base;
#line 42 "../src/LoginOptions/ManualLogin.vala"
	result = FALSE;
#line 42 "../src/LoginOptions/ManualLogin.vala"
	return result;
#line 163 "ManualLogin.c"
}

static void
manual_login_class_init (ManualLoginClass * klass,
                         gpointer klass_data)
{
#line 21 "../src/LoginOptions/ManualLogin.vala"
	manual_login_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/LoginOptions/ManualLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_name = manual_login_real_get_name;
#line 21 "../src/LoginOptions/ManualLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_display_name = manual_login_real_get_display_name;
#line 21 "../src/LoginOptions/ManualLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_provides_login_name = manual_login_real_get_provides_login_name;
#line 21 "../src/LoginOptions/ManualLogin.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_manual_login_get_property;
#line 21 "../src/LoginOptions/ManualLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MANUAL_LOGIN_NAME_PROPERTY, manual_login_properties[MANUAL_LOGIN_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/ManualLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MANUAL_LOGIN_DISPLAY_NAME_PROPERTY, manual_login_properties[MANUAL_LOGIN_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/ManualLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MANUAL_LOGIN_PROVIDES_LOGIN_NAME_PROPERTY, manual_login_properties[MANUAL_LOGIN_PROVIDES_LOGIN_NAME_PROPERTY] = g_param_spec_boolean ("provides-login-name", "provides-login-name", "provides-login-name", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 186 "ManualLogin.c"
}

static void
manual_login_instance_init (ManualLogin * self,
                            gpointer klass)
{
}

GType
manual_login_get_type (void)
{
	static volatile gsize manual_login_type_id__volatile = 0;
	if (g_once_init_enter (&manual_login_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ManualLoginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) manual_login_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ManualLogin), 0, (GInstanceInitFunc) manual_login_instance_init, NULL };
		GType manual_login_type_id;
		manual_login_type_id = g_type_register_static (TYPE_LOGIN_OPTION, "ManualLogin", &g_define_type_info, 0);
		g_once_init_leave (&manual_login_type_id__volatile, manual_login_type_id);
	}
	return manual_login_type_id__volatile;
}

static void
_vala_manual_login_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ManualLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MANUAL_LOGIN, ManualLogin);
#line 21 "../src/LoginOptions/ManualLogin.vala"
	switch (property_id) {
#line 21 "../src/LoginOptions/ManualLogin.vala"
		case MANUAL_LOGIN_NAME_PROPERTY:
#line 21 "../src/LoginOptions/ManualLogin.vala"
		g_value_set_string (value, login_option_get_name ((LoginOption*) self));
#line 21 "../src/LoginOptions/ManualLogin.vala"
		break;
#line 21 "../src/LoginOptions/ManualLogin.vala"
		case MANUAL_LOGIN_DISPLAY_NAME_PROPERTY:
#line 21 "../src/LoginOptions/ManualLogin.vala"
		g_value_set_string (value, login_option_get_display_name ((LoginOption*) self));
#line 21 "../src/LoginOptions/ManualLogin.vala"
		break;
#line 21 "../src/LoginOptions/ManualLogin.vala"
		case MANUAL_LOGIN_PROVIDES_LOGIN_NAME_PROPERTY:
#line 21 "../src/LoginOptions/ManualLogin.vala"
		g_value_set_boolean (value, login_option_get_provides_login_name ((LoginOption*) self));
#line 21 "../src/LoginOptions/ManualLogin.vala"
		break;
#line 236 "ManualLogin.c"
		default:
#line 21 "../src/LoginOptions/ManualLogin.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/LoginOptions/ManualLogin.vala"
		break;
#line 242 "ManualLogin.c"
	}
}

