/* UserLogin.c generated by valac 0.43.6, the Vala compiler
 * generated from UserLogin.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC. (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>
#include <gio/gio.h>

#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
typedef struct _LoginOptionPrivate LoginOptionPrivate;

#define TYPE_USER_LOGIN (user_login_get_type ())
#define USER_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LOGIN, UserLogin))
#define USER_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LOGIN, UserLoginClass))
#define IS_USER_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LOGIN))
#define IS_USER_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LOGIN))
#define USER_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LOGIN, UserLoginClass))

typedef struct _UserLogin UserLogin;
typedef struct _UserLoginClass UserLoginClass;
typedef struct _UserLoginPrivate UserLoginPrivate;
enum  {
	USER_LOGIN_0_PROPERTY,
	USER_LOGIN_LIGHTDM_USER_PROPERTY,
	USER_LOGIN_AVATAR_PATH_PROPERTY,
	USER_LOGIN_BACKGROUND_PROPERTY,
	USER_LOGIN_DISPLAY_NAME_PROPERTY,
	USER_LOGIN_NAME_PROPERTY,
	USER_LOGIN_LOGGED_IN_PROPERTY,
	USER_LOGIN_SESSION_PROPERTY,
	USER_LOGIN_NUM_PROPERTIES
};
static GParamSpec* user_login_properties[USER_LOGIN_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _LoginOption {
	GObject parent_instance;
	LoginOptionPrivate * priv;
};

struct _LoginOptionClass {
	GObjectClass parent_class;
	const gchar* (*get_display_name) (LoginOption* self);
	const gchar* (*get_avatar_path) (LoginOption* self);
	const gchar* (*get_background) (LoginOption* self);
	const gchar* (*get_name) (LoginOption* self);
	gboolean (*get_logged_in) (LoginOption* self);
	gboolean (*get_is_guest) (LoginOption* self);
	gboolean (*get_provides_login_name) (LoginOption* self);
	const gchar* (*get_session) (LoginOption* self);
};

struct _UserLogin {
	LoginOption parent_instance;
	UserLoginPrivate * priv;
};

struct _UserLoginClass {
	LoginOptionClass parent_class;
};

struct _UserLoginPrivate {
	LightDMUser* _lightdm_user;
	gchar* background_path;
};

static gint UserLogin_private_offset;
static gpointer user_login_parent_class = NULL;

GType login_option_get_type (void) G_GNUC_CONST;
GType user_login_get_type (void) G_GNUC_CONST;
UserLogin* user_login_new (gint index,
                           LightDMUser* user);
UserLogin* user_login_construct (GType object_type,
                                 gint index,
                                 LightDMUser* user);
LoginOption* login_option_construct (GType object_type,
                                     gint index);
static void user_login_set_lightdm_user (UserLogin* self,
                                  LightDMUser* value);
LightDMUser* user_login_get_lightdm_user (UserLogin* self);
static void user_login_finalize (GObject * obj);
const gchar* login_option_get_avatar_path (LoginOption* self);
const gchar* login_option_get_background (LoginOption* self);
const gchar* login_option_get_display_name (LoginOption* self);
const gchar* login_option_get_name (LoginOption* self);
gboolean login_option_get_logged_in (LoginOption* self);
const gchar* login_option_get_session (LoginOption* self);
static void _vala_user_login_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_user_login_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
user_login_get_instance_private (UserLogin* self)
{
	return G_STRUCT_MEMBER_P (self, UserLogin_private_offset);
}

UserLogin*
user_login_construct (GType object_type,
                      gint index,
                      LightDMUser* user)
{
	UserLogin * self = NULL;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 26 "../src/LoginOptions/UserLogin.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 27 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) login_option_construct (object_type, index);
#line 28 "../src/LoginOptions/UserLogin.vala"
	user_login_set_lightdm_user (self, user);
#line 30 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 30 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_background (_tmp0_);
#line 30 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 30 "../src/LoginOptions/UserLogin.vala"
	if (_tmp2_ == NULL) {
#line 161 "UserLogin.c"
		{
			gchar* path = NULL;
			LightDMUser* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			GFile* background_directory = NULL;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			GFileEnumerator* enumerator = NULL;
			GFile* _tmp9_;
			GFileEnumerator* _tmp10_;
			GFileInfo* file_info = NULL;
			gchar* file_name = NULL;
			gchar* _tmp11_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
#line 32 "../src/LoginOptions/UserLogin.vala"
			_tmp3_ = self->priv->_lightdm_user;
#line 32 "../src/LoginOptions/UserLogin.vala"
			_tmp4_ = lightdm_user_get_name (_tmp3_);
#line 32 "../src/LoginOptions/UserLogin.vala"
			_tmp5_ = _tmp4_;
#line 32 "../src/LoginOptions/UserLogin.vala"
			_tmp6_ = g_build_filename ("/var", "lib", "lightdm-data", _tmp5_, "wallpaper", NULL);
#line 32 "../src/LoginOptions/UserLogin.vala"
			path = _tmp6_;
#line 33 "../src/LoginOptions/UserLogin.vala"
			_tmp7_ = path;
#line 33 "../src/LoginOptions/UserLogin.vala"
			_tmp8_ = g_file_new_for_path (_tmp7_);
#line 33 "../src/LoginOptions/UserLogin.vala"
			background_directory = _tmp8_;
#line 34 "../src/LoginOptions/UserLogin.vala"
			_tmp9_ = background_directory;
#line 34 "../src/LoginOptions/UserLogin.vala"
			_tmp10_ = g_file_enumerate_children (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_NAME, 0, NULL, &_inner_error_);
#line 34 "../src/LoginOptions/UserLogin.vala"
			enumerator = _tmp10_;
#line 34 "../src/LoginOptions/UserLogin.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 34 "../src/LoginOptions/UserLogin.vala"
				_g_object_unref0 (background_directory);
#line 34 "../src/LoginOptions/UserLogin.vala"
				_g_free0 (path);
#line 210 "UserLogin.c"
				goto __catch17_g_error;
			}
#line 37 "../src/LoginOptions/UserLogin.vala"
			_tmp11_ = g_strdup ("");
#line 37 "../src/LoginOptions/UserLogin.vala"
			file_name = _tmp11_;
#line 38 "../src/LoginOptions/UserLogin.vala"
			while (TRUE) {
#line 219 "UserLogin.c"
				GFileInfo* _tmp12_ = NULL;
				GFileEnumerator* _tmp13_;
				GFileInfo* _tmp14_;
				GFileInfo* _tmp15_;
				GFileInfo* _tmp16_;
				GFileInfo* _tmp17_;
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp13_ = enumerator;
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp14_ = g_file_enumerator_next_file (_tmp13_, NULL, &_inner_error_);
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp12_ = _tmp14_;
#line 38 "../src/LoginOptions/UserLogin.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_free0 (file_name);
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_object_unref0 (file_info);
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_object_unref0 (enumerator);
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_object_unref0 (background_directory);
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_free0 (path);
#line 244 "UserLogin.c"
					goto __catch17_g_error;
				}
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp15_ = _tmp12_;
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp12_ = NULL;
#line 38 "../src/LoginOptions/UserLogin.vala"
				_g_object_unref0 (file_info);
#line 38 "../src/LoginOptions/UserLogin.vala"
				file_info = _tmp15_;
#line 38 "../src/LoginOptions/UserLogin.vala"
				_tmp16_ = file_info;
#line 38 "../src/LoginOptions/UserLogin.vala"
				if (!(_tmp16_ != NULL)) {
#line 38 "../src/LoginOptions/UserLogin.vala"
					_g_object_unref0 (_tmp12_);
#line 38 "../src/LoginOptions/UserLogin.vala"
					break;
#line 263 "UserLogin.c"
				}
#line 39 "../src/LoginOptions/UserLogin.vala"
				_tmp17_ = file_info;
#line 39 "../src/LoginOptions/UserLogin.vala"
				if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_REGULAR) {
#line 269 "UserLogin.c"
					GFileInfo* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 40 "../src/LoginOptions/UserLogin.vala"
					_tmp18_ = file_info;
#line 40 "../src/LoginOptions/UserLogin.vala"
					_tmp19_ = g_file_info_get_name (_tmp18_);
#line 40 "../src/LoginOptions/UserLogin.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 40 "../src/LoginOptions/UserLogin.vala"
					_g_free0 (file_name);
#line 40 "../src/LoginOptions/UserLogin.vala"
					file_name = _tmp20_;
#line 41 "../src/LoginOptions/UserLogin.vala"
					_g_object_unref0 (_tmp12_);
#line 41 "../src/LoginOptions/UserLogin.vala"
					break;
#line 287 "UserLogin.c"
				}
#line 38 "../src/LoginOptions/UserLogin.vala"
				_g_object_unref0 (_tmp12_);
#line 291 "UserLogin.c"
			}
#line 45 "../src/LoginOptions/UserLogin.vala"
			_tmp21_ = path;
#line 45 "../src/LoginOptions/UserLogin.vala"
			_tmp22_ = file_name;
#line 45 "../src/LoginOptions/UserLogin.vala"
			_tmp23_ = g_build_filename (_tmp21_, _tmp22_, NULL);
#line 45 "../src/LoginOptions/UserLogin.vala"
			_g_free0 (path);
#line 45 "../src/LoginOptions/UserLogin.vala"
			path = _tmp23_;
#line 46 "../src/LoginOptions/UserLogin.vala"
			_tmp24_ = path;
#line 46 "../src/LoginOptions/UserLogin.vala"
			_tmp25_ = g_strdup (_tmp24_);
#line 46 "../src/LoginOptions/UserLogin.vala"
			_g_free0 (self->priv->background_path);
#line 46 "../src/LoginOptions/UserLogin.vala"
			self->priv->background_path = _tmp25_;
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_free0 (file_name);
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_object_unref0 (file_info);
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_object_unref0 (enumerator);
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_object_unref0 (background_directory);
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_free0 (path);
#line 321 "UserLogin.c"
		}
		goto __finally17;
		__catch17_g_error:
		{
			GError* e = NULL;
			GError* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 31 "../src/LoginOptions/UserLogin.vala"
			e = _inner_error_;
#line 31 "../src/LoginOptions/UserLogin.vala"
			_inner_error_ = NULL;
#line 48 "../src/LoginOptions/UserLogin.vala"
			_tmp26_ = e;
#line 48 "../src/LoginOptions/UserLogin.vala"
			_tmp27_ = _tmp26_->message;
#line 48 "../src/LoginOptions/UserLogin.vala"
			g_warning ("UserLogin.vala:48: %s", _tmp27_);
#line 49 "../src/LoginOptions/UserLogin.vala"
			_tmp28_ = g_strdup ("");
#line 49 "../src/LoginOptions/UserLogin.vala"
			_g_free0 (self->priv->background_path);
#line 49 "../src/LoginOptions/UserLogin.vala"
			self->priv->background_path = _tmp28_;
#line 31 "../src/LoginOptions/UserLogin.vala"
			_g_error_free0 (e);
#line 348 "UserLogin.c"
		}
		__finally17:
#line 31 "../src/LoginOptions/UserLogin.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31 "../src/LoginOptions/UserLogin.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 31 "../src/LoginOptions/UserLogin.vala"
			g_clear_error (&_inner_error_);
#line 31 "../src/LoginOptions/UserLogin.vala"
			return NULL;
#line 359 "UserLogin.c"
		}
	} else {
		LightDMUser* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 52 "../src/LoginOptions/UserLogin.vala"
		_tmp29_ = self->priv->_lightdm_user;
#line 52 "../src/LoginOptions/UserLogin.vala"
		_tmp30_ = lightdm_user_get_background (_tmp29_);
#line 52 "../src/LoginOptions/UserLogin.vala"
		_tmp31_ = _tmp30_;
#line 52 "../src/LoginOptions/UserLogin.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 52 "../src/LoginOptions/UserLogin.vala"
		_g_free0 (self->priv->background_path);
#line 52 "../src/LoginOptions/UserLogin.vala"
		self->priv->background_path = _tmp32_;
#line 378 "UserLogin.c"
	}
#line 26 "../src/LoginOptions/UserLogin.vala"
	return self;
#line 382 "UserLogin.c"
}

UserLogin*
user_login_new (gint index,
                LightDMUser* user)
{
#line 26 "../src/LoginOptions/UserLogin.vala"
	return user_login_construct (TYPE_USER_LOGIN, index, user);
#line 391 "UserLogin.c"
}

LightDMUser*
user_login_get_lightdm_user (UserLogin* self)
{
	LightDMUser* result;
	LightDMUser* _tmp0_;
#line 23 "../src/LoginOptions/UserLogin.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 23 "../src/LoginOptions/UserLogin.vala"
	result = _tmp0_;
#line 23 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 407 "UserLogin.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/LoginOptions/UserLogin.vala"
	return self ? g_object_ref (self) : NULL;
#line 415 "UserLogin.c"
}

static void
user_login_set_lightdm_user (UserLogin* self,
                             LightDMUser* value)
{
#line 23 "../src/LoginOptions/UserLogin.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/LoginOptions/UserLogin.vala"
	if (user_login_get_lightdm_user (self) != value) {
#line 426 "UserLogin.c"
		LightDMUser* _tmp0_;
#line 23 "../src/LoginOptions/UserLogin.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/LoginOptions/UserLogin.vala"
		_g_object_unref0 (self->priv->_lightdm_user);
#line 23 "../src/LoginOptions/UserLogin.vala"
		self->priv->_lightdm_user = _tmp0_;
#line 23 "../src/LoginOptions/UserLogin.vala"
		g_object_notify_by_pspec ((GObject *) self, user_login_properties[USER_LOGIN_LIGHTDM_USER_PROPERTY]);
#line 436 "UserLogin.c"
	}
}

static const gchar*
user_login_real_get_avatar_path (LoginOption* base)
{
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 57 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 58 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 58 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_image (_tmp0_);
#line 58 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/LoginOptions/UserLogin.vala"
	result = _tmp2_;
#line 58 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 460 "UserLogin.c"
}

static const gchar*
user_login_real_get_background (LoginOption* base)
{
	const gchar* result;
	UserLogin* self;
	const gchar* _tmp0_;
#line 63 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 64 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->background_path;
#line 64 "../src/LoginOptions/UserLogin.vala"
	result = _tmp0_;
#line 64 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 477 "UserLogin.c"
}

static const gchar*
user_login_real_get_display_name (LoginOption* base)
{
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 69 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 70 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 70 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_display_name (_tmp0_);
#line 70 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 70 "../src/LoginOptions/UserLogin.vala"
	result = _tmp2_;
#line 70 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 500 "UserLogin.c"
}

static const gchar*
user_login_real_get_name (LoginOption* base)
{
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 75 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 76 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 76 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_name (_tmp0_);
#line 76 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/LoginOptions/UserLogin.vala"
	result = _tmp2_;
#line 76 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 523 "UserLogin.c"
}

static gboolean
user_login_real_get_logged_in (LoginOption* base)
{
	gboolean result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 81 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 82 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 82 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_logged_in (_tmp0_);
#line 82 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 82 "../src/LoginOptions/UserLogin.vala"
	result = _tmp2_;
#line 82 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 546 "UserLogin.c"
}

static const gchar*
user_login_real_get_session (LoginOption* base)
{
	const gchar* result;
	UserLogin* self;
	LightDMUser* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 87 "../src/LoginOptions/UserLogin.vala"
	self = (UserLogin*) base;
#line 88 "../src/LoginOptions/UserLogin.vala"
	_tmp0_ = self->priv->_lightdm_user;
#line 88 "../src/LoginOptions/UserLogin.vala"
	_tmp1_ = lightdm_user_get_session (_tmp0_);
#line 88 "../src/LoginOptions/UserLogin.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/LoginOptions/UserLogin.vala"
	result = _tmp2_;
#line 88 "../src/LoginOptions/UserLogin.vala"
	return result;
#line 569 "UserLogin.c"
}

static void
user_login_class_init (UserLoginClass * klass,
                       gpointer klass_data)
{
#line 21 "../src/LoginOptions/UserLogin.vala"
	user_login_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_type_class_adjust_private_offset (klass, &UserLogin_private_offset);
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_avatar_path = user_login_real_get_avatar_path;
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_background = user_login_real_get_background;
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_display_name = user_login_real_get_display_name;
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_name = user_login_real_get_name;
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_logged_in = user_login_real_get_logged_in;
#line 21 "../src/LoginOptions/UserLogin.vala"
	LOGIN_OPTION_CLASS (klass)->get_session = user_login_real_get_session;
#line 21 "../src/LoginOptions/UserLogin.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_user_login_get_property;
#line 21 "../src/LoginOptions/UserLogin.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_user_login_set_property;
#line 21 "../src/LoginOptions/UserLogin.vala"
	G_OBJECT_CLASS (klass)->finalize = user_login_finalize;
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_LIGHTDM_USER_PROPERTY, user_login_properties[USER_LOGIN_LIGHTDM_USER_PROPERTY] = g_param_spec_object ("lightdm-user", "lightdm-user", "lightdm-user", lightdm_user_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_AVATAR_PATH_PROPERTY, user_login_properties[USER_LOGIN_AVATAR_PATH_PROPERTY] = g_param_spec_string ("avatar-path", "avatar-path", "avatar-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_BACKGROUND_PROPERTY, user_login_properties[USER_LOGIN_BACKGROUND_PROPERTY] = g_param_spec_string ("background", "background", "background", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_DISPLAY_NAME_PROPERTY, user_login_properties[USER_LOGIN_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_NAME_PROPERTY, user_login_properties[USER_LOGIN_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_LOGGED_IN_PROPERTY, user_login_properties[USER_LOGIN_LOGGED_IN_PROPERTY] = g_param_spec_boolean ("logged-in", "logged-in", "logged-in", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../src/LoginOptions/UserLogin.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LOGIN_SESSION_PROPERTY, user_login_properties[USER_LOGIN_SESSION_PROPERTY] = g_param_spec_string ("session", "session", "session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 612 "UserLogin.c"
}

static void
user_login_instance_init (UserLogin * self,
                          gpointer klass)
{
#line 21 "../src/LoginOptions/UserLogin.vala"
	self->priv = user_login_get_instance_private (self);
#line 621 "UserLogin.c"
}

static void
user_login_finalize (GObject * obj)
{
	UserLogin * self;
#line 21 "../src/LoginOptions/UserLogin.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LOGIN, UserLogin);
#line 23 "../src/LoginOptions/UserLogin.vala"
	_g_object_unref0 (self->priv->_lightdm_user);
#line 24 "../src/LoginOptions/UserLogin.vala"
	_g_free0 (self->priv->background_path);
#line 21 "../src/LoginOptions/UserLogin.vala"
	G_OBJECT_CLASS (user_login_parent_class)->finalize (obj);
#line 636 "UserLogin.c"
}

GType
user_login_get_type (void)
{
	static volatile gsize user_login_type_id__volatile = 0;
	if (g_once_init_enter (&user_login_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserLoginClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_login_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserLogin), 0, (GInstanceInitFunc) user_login_instance_init, NULL };
		GType user_login_type_id;
		user_login_type_id = g_type_register_static (TYPE_LOGIN_OPTION, "UserLogin", &g_define_type_info, 0);
		UserLogin_private_offset = g_type_add_instance_private (user_login_type_id, sizeof (UserLoginPrivate));
		g_once_init_leave (&user_login_type_id__volatile, user_login_type_id);
	}
	return user_login_type_id__volatile;
}

static void
_vala_user_login_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	UserLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LOGIN, UserLogin);
#line 21 "../src/LoginOptions/UserLogin.vala"
	switch (property_id) {
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_LIGHTDM_USER_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_object (value, user_login_get_lightdm_user (self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_AVATAR_PATH_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_string (value, login_option_get_avatar_path ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_BACKGROUND_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_string (value, login_option_get_background ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_DISPLAY_NAME_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_string (value, login_option_get_display_name ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_NAME_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_string (value, login_option_get_name ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_LOGGED_IN_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_boolean (value, login_option_get_logged_in ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_SESSION_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		g_value_set_string (value, login_option_get_session ((LoginOption*) self));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 705 "UserLogin.c"
		default:
#line 21 "../src/LoginOptions/UserLogin.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 711 "UserLogin.c"
	}
}

static void
_vala_user_login_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	UserLogin * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LOGIN, UserLogin);
#line 21 "../src/LoginOptions/UserLogin.vala"
	switch (property_id) {
#line 21 "../src/LoginOptions/UserLogin.vala"
		case USER_LOGIN_LIGHTDM_USER_PROPERTY:
#line 21 "../src/LoginOptions/UserLogin.vala"
		user_login_set_lightdm_user (self, g_value_get_object (value));
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 731 "UserLogin.c"
		default:
#line 21 "../src/LoginOptions/UserLogin.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/LoginOptions/UserLogin.vala"
		break;
#line 737 "UserLogin.c"
	}
}

