/* LoginBox.c generated by valac 0.43.6, the Vala compiler
 * generated from LoginBox.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
* Copyright (c) 2011-2017 elementary LLC. (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <clutter-gtk/clutter-gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <lightdm.h>
#include <gtk/gtk.h>
#include <clutter/clutter.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define TYPE_LOGIN_MASK (login_mask_get_type ())
#define LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_MASK, LoginMask))
#define IS_LOGIN_MASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_MASK))
#define LOGIN_MASK_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_MASK, LoginMaskIface))

typedef struct _LoginMask LoginMask;
typedef struct _LoginMaskIface LoginMaskIface;
typedef enum  {
	PROMPT_TYPE_SECRET,
	PROMPT_TYPE_QUESTION,
	PROMPT_TYPE_CONFIRM_LOGIN,
	PROMPT_TYPE_FPRINT
} PromptType;

#define TYPE_PROMPT_TYPE (prompt_type_get_type ())
typedef enum  {
	PROMPT_TEXT_USERNAME,
	PROMPT_TEXT_PASSWORD,
	PROMPT_TEXT_OTHER
} PromptText;

#define TYPE_PROMPT_TEXT (prompt_text_get_type ())
typedef enum  {
	MESSAGE_TEXT_FPRINT_SWIPE,
	MESSAGE_TEXT_FPRINT_SWIPE_AGAIN,
	MESSAGE_TEXT_FPRINT_SWIPE_TOO_SHORT,
	MESSAGE_TEXT_FPRINT_NOT_CENTERED,
	MESSAGE_TEXT_FPRINT_REMOVE,
	MESSAGE_TEXT_FPRINT_PLACE,
	MESSAGE_TEXT_FPRINT_PLACE_AGAIN,
	MESSAGE_TEXT_FPRINT_NO_MATCH,
	MESSAGE_TEXT_FPRINT_TIMEOUT,
	MESSAGE_TEXT_FPRINT_ERROR,
	MESSAGE_TEXT_FAILED,
	MESSAGE_TEXT_OTHER
} MessageText;

#define TYPE_MESSAGE_TEXT (message_text_get_type ())

#define TYPE_LOGIN_BOX (login_box_get_type ())
#define LOGIN_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_BOX, LoginBox))
#define LOGIN_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_BOX, LoginBoxClass))
#define IS_LOGIN_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_BOX))
#define IS_LOGIN_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_BOX))
#define LOGIN_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_BOX, LoginBoxClass))

typedef struct _LoginBox LoginBox;
typedef struct _LoginBoxClass LoginBoxClass;
typedef struct _LoginBoxPrivate LoginBoxPrivate;

#define TYPE_CREDENTIALS_AREA (credentials_area_get_type ())
#define CREDENTIALS_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CREDENTIALS_AREA, CredentialsArea))
#define CREDENTIALS_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CREDENTIALS_AREA, CredentialsAreaClass))
#define IS_CREDENTIALS_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CREDENTIALS_AREA))
#define IS_CREDENTIALS_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CREDENTIALS_AREA))
#define CREDENTIALS_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CREDENTIALS_AREA, CredentialsAreaClass))

typedef struct _CredentialsArea CredentialsArea;
typedef struct _CredentialsAreaClass CredentialsAreaClass;

#define TYPE_LOGIN_OPTION (login_option_get_type ())
#define LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_OPTION, LoginOption))
#define LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOGIN_OPTION, LoginOptionClass))
#define IS_LOGIN_OPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_OPTION))
#define IS_LOGIN_OPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOGIN_OPTION))
#define LOGIN_OPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOGIN_OPTION, LoginOptionClass))

typedef struct _LoginOption LoginOption;
typedef struct _LoginOptionClass LoginOptionClass;
enum  {
	LOGIN_BOX_0_PROPERTY,
	LOGIN_BOX_SELECTED_PROPERTY,
	LOGIN_BOX_LOGIN_NAME_PROPERTY,
	LOGIN_BOX_LOGIN_SESSION_PROPERTY,
	LOGIN_BOX_USER_PROPERTY,
	LOGIN_BOX_NUM_PROPERTIES
};
static GParamSpec* login_box_properties[LOGIN_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_LOGIN_GATEWAY (login_gateway_get_type ())
#define LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOGIN_GATEWAY, LoginGateway))
#define IS_LOGIN_GATEWAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOGIN_GATEWAY))
#define LOGIN_GATEWAY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LOGIN_GATEWAY, LoginGatewayIface))

typedef struct _LoginGateway LoginGateway;
typedef struct _LoginGatewayIface LoginGatewayIface;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	LOGIN_BOX_CLICKED_SIGNAL,
	LOGIN_BOX_NUM_SIGNALS
};
static guint login_box_signals[LOGIN_BOX_NUM_SIGNALS] = {0};

struct _LoginMaskIface {
	GTypeInterface parent_iface;
	void (*show_prompt) (LoginMask* self, PromptType type, PromptText prompttext, const gchar* text);
	void (*show_message) (LoginMask* self, LightDMMessageType type, MessageText messagetext, const gchar* text);
	void (*not_authenticated) (LoginMask* self);
	void (*login_aborted) (LoginMask* self);
	const gchar* (*get_login_name) (LoginMask* self);
	const gchar* (*get_login_session) (LoginMask* self);
};

struct _LoginBox {
	GtkClutterActor parent_instance;
	LoginBoxPrivate * priv;
};

struct _LoginBoxClass {
	GtkClutterActorClass parent_class;
};

struct _LoginBoxPrivate {
	CredentialsArea* credentials_area;
	gboolean _selected;
	LoginOption* _user;
};

struct _LoginGatewayIface {
	GTypeInterface parent_iface;
	void (*login_with_mask) (LoginGateway* self, LoginMask* mask, gboolean guest);
	void (*respond) (LoginGateway* self, const gchar* message);
	void (*start_session) (LoginGateway* self);
	gboolean (*get_hide_users) (LoginGateway* self);
	gboolean (*get_has_guest_account) (LoginGateway* self);
	gboolean (*get_show_manual_login) (LoginGateway* self);
	gboolean (*get_lock) (LoginGateway* self);
	const gchar* (*get_default_session) (LoginGateway* self);
	const gchar* (*get_select_user) (LoginGateway* self);
};

static gint LoginBox_private_offset;
static gpointer login_box_parent_class = NULL;
static LoginMaskIface * login_box_login_mask_parent_iface = NULL;

GType prompt_type_get_type (void) G_GNUC_CONST;
GType prompt_text_get_type (void) G_GNUC_CONST;
GType message_text_get_type (void) G_GNUC_CONST;
GType login_mask_get_type (void) G_GNUC_CONST;
GType login_box_get_type (void) G_GNUC_CONST;
GType credentials_area_get_type (void) G_GNUC_CONST;
GType login_option_get_type (void) G_GNUC_CONST;
LoginBox* login_box_new (LoginOption* user);
LoginBox* login_box_construct (GType object_type,
                               LoginOption* user);
static void login_box_start_login (LoginBox* self);
GType login_gateway_get_type (void) G_GNUC_CONST;
LoginGateway* pantheon_greeter_get_login_gateway (void);
void login_gateway_login_with_mask (LoginGateway* self,
                                    LoginMask* mask,
                                    gboolean guest);
LoginOption* login_box_get_user (LoginBox* self);
gboolean login_option_get_is_guest (LoginOption* self);
void login_box_pass_focus (LoginBox* self);
gboolean login_option_get_provides_login_name (LoginOption* self);
void credentials_area_pass_focus (CredentialsArea* self);
static void login_box_shake (LoginBox* self);
void credentials_area_shake (CredentialsArea* self);
static void login_box_real_show_prompt (LoginMask* base,
                                 PromptType type,
                                 PromptText prompttext,
                                 const gchar* text);
void credentials_area_show_prompt (CredentialsArea* self,
                                   PromptType type);
static void login_box_real_show_message (LoginMask* base,
                                  LightDMMessageType type,
                                  MessageText messagetext,
                                  const gchar* text);
void credentials_area_show_message (CredentialsArea* self,
                                    LightDMMessageType type,
                                    MessageText messagetext,
                                    const gchar* text);
static void login_box_real_not_authenticated (LoginMask* base);
void credentials_area_remove_credentials (CredentialsArea* self);
static void login_box_real_login_aborted (LoginMask* base);
gboolean login_box_get_selected (LoginBox* self);
void login_box_set_selected (LoginBox* self,
                             gboolean value);
const gchar* login_option_get_name (LoginOption* self);
const gchar* credentials_area_get_login_name (CredentialsArea* self);
const gchar* credentials_area_get_current_session (CredentialsArea* self);
static void login_box_set_user (LoginBox* self,
                         LoginOption* value);
static GObject * login_box_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
CredentialsArea* credentials_area_new (LoginBox* login_box,
                                       LoginOption* login_option);
CredentialsArea* credentials_area_construct (GType object_type,
                                             LoginBox* login_box,
                                             LoginOption* login_option);
const gchar* login_option_get_avatar_path (LoginOption* self);
static gboolean _login_box___lambda17_ (LoginBox* self);
static gboolean __login_box___lambda17__clutter_actor_button_press_event (ClutterActor* _sender,
                                                                   ClutterButtonEvent* event,
                                                                   gpointer self);
static gboolean _login_box___lambda18_ (LoginBox* self);
static gboolean __login_box___lambda18__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                GdkEventButton* event,
                                                                gpointer self);
gboolean login_option_get_logged_in (LoginOption* self);
static void _login_box___lambda19_ (LoginBox* self,
                             const gchar* answer);
void login_gateway_respond (LoginGateway* self,
                            const gchar* message);
static void __login_box___lambda19__credentials_area_replied (CredentialsArea* _sender,
                                                       const gchar* text,
                                                       gpointer self);
static void _login_box___lambda20_ (LoginBox* self,
                             const gchar* name);
static void __login_box___lambda20__credentials_area_entered_login_name (CredentialsArea* _sender,
                                                                  const gchar* name,
                                                                  gpointer self);
static void login_box_finalize (GObject * obj);
const gchar* login_mask_get_login_name (LoginMask* self);
const gchar* login_mask_get_login_session (LoginMask* self);
static void _vala_login_box_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_login_box_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
login_box_get_instance_private (LoginBox* self)
{
	return G_STRUCT_MEMBER_P (self, LoginBox_private_offset);
}

LoginBox*
login_box_construct (GType object_type,
                     LoginOption* user)
{
	LoginBox * self = NULL;
#line 57 "../src/Widgets/LoginBox.vala"
	g_return_val_if_fail (user != NULL, NULL);
#line 58 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) g_object_new (object_type, "user", user, NULL);
#line 57 "../src/Widgets/LoginBox.vala"
	return self;
#line 282 "LoginBox.c"
}

LoginBox*
login_box_new (LoginOption* user)
{
#line 57 "../src/Widgets/LoginBox.vala"
	return login_box_construct (TYPE_LOGIN_BOX, user);
#line 290 "LoginBox.c"
}

/**
     * Starts the login procedure. Necessary to call this before the user
     * can enter something so that the LoginGateway can tell
     * us what kind of prompt he wants.
     */
static void
login_box_start_login (LoginBox* self)
{
	LoginGateway* _tmp0_;
	LoginGateway* _tmp1_;
	LoginOption* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 124 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/Widgets/LoginBox.vala"
	_tmp0_ = pantheon_greeter_get_login_gateway ();
#line 125 "../src/Widgets/LoginBox.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/Widgets/LoginBox.vala"
	_tmp2_ = self->priv->_user;
#line 125 "../src/Widgets/LoginBox.vala"
	_tmp3_ = login_option_get_is_guest (_tmp2_);
#line 125 "../src/Widgets/LoginBox.vala"
	_tmp4_ = _tmp3_;
#line 125 "../src/Widgets/LoginBox.vala"
	login_gateway_login_with_mask (_tmp1_, (LoginMask*) self, _tmp4_);
#line 320 "LoginBox.c"
}

void
login_box_pass_focus (LoginBox* self)
{
	LoginOption* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	CredentialsArea* _tmp3_;
#line 128 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->_user;
#line 131 "../src/Widgets/LoginBox.vala"
	_tmp1_ = login_option_get_provides_login_name (_tmp0_);
#line 131 "../src/Widgets/LoginBox.vala"
	_tmp2_ = _tmp1_;
#line 131 "../src/Widgets/LoginBox.vala"
	if (_tmp2_) {
#line 132 "../src/Widgets/LoginBox.vala"
		login_box_start_login (self);
#line 342 "LoginBox.c"
	}
#line 134 "../src/Widgets/LoginBox.vala"
	_tmp3_ = self->priv->credentials_area;
#line 134 "../src/Widgets/LoginBox.vala"
	credentials_area_pass_focus (_tmp3_);
#line 348 "LoginBox.c"
}

static void
login_box_shake (LoginBox* self)
{
	CredentialsArea* _tmp0_;
#line 137 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 138 "../src/Widgets/LoginBox.vala"
	credentials_area_shake (_tmp0_);
#line 139 "../src/Widgets/LoginBox.vala"
	login_box_start_login (self);
#line 140 "../src/Widgets/LoginBox.vala"
	return;
#line 365 "LoginBox.c"
}

static void
login_box_real_show_prompt (LoginMask* base,
                            PromptType type,
                            PromptText prompttext,
                            const gchar* text)
{
	LoginBox * self;
	CredentialsArea* _tmp0_;
#line 143 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 143 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (text != NULL);
#line 144 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 144 "../src/Widgets/LoginBox.vala"
	credentials_area_show_prompt (_tmp0_, type);
#line 384 "LoginBox.c"
}

static void
login_box_real_show_message (LoginMask* base,
                             LightDMMessageType type,
                             MessageText messagetext,
                             const gchar* text)
{
	LoginBox * self;
	CredentialsArea* _tmp0_;
#line 147 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 147 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (text != NULL);
#line 148 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 148 "../src/Widgets/LoginBox.vala"
	credentials_area_show_message (_tmp0_, type, messagetext, text);
#line 403 "LoginBox.c"
}

static void
login_box_real_not_authenticated (LoginMask* base)
{
	LoginBox * self;
	CredentialsArea* _tmp0_;
#line 151 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 152 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 152 "../src/Widgets/LoginBox.vala"
	credentials_area_remove_credentials (_tmp0_);
#line 153 "../src/Widgets/LoginBox.vala"
	login_box_shake (self);
#line 419 "LoginBox.c"
}

static void
login_box_real_login_aborted (LoginMask* base)
{
	LoginBox * self;
	CredentialsArea* _tmp0_;
#line 156 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 157 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 157 "../src/Widgets/LoginBox.vala"
	credentials_area_remove_credentials (_tmp0_);
#line 433 "LoginBox.c"
}

gboolean
login_box_get_selected (LoginBox* self)
{
	gboolean result;
#line 30 "../src/Widgets/LoginBox.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/Widgets/LoginBox.vala"
	result = self->priv->_selected;
#line 31 "../src/Widgets/LoginBox.vala"
	return result;
#line 446 "LoginBox.c"
}

void
login_box_set_selected (LoginBox* self,
                        gboolean value)
{
	CredentialsArea* _tmp0_;
	CredentialsArea* _tmp1_;
#line 33 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/LoginBox.vala"
	self->priv->_selected = value;
#line 35 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 35 "../src/Widgets/LoginBox.vala"
	credentials_area_remove_credentials (_tmp0_);
#line 36 "../src/Widgets/LoginBox.vala"
	_tmp1_ = self->priv->credentials_area;
#line 36 "../src/Widgets/LoginBox.vala"
	gtk_revealer_set_reveal_child ((GtkRevealer*) _tmp1_, value);
#line 33 "../src/Widgets/LoginBox.vala"
	g_object_notify_by_pspec ((GObject *) self, login_box_properties[LOGIN_BOX_SELECTED_PROPERTY]);
#line 469 "LoginBox.c"
}

static const gchar*
login_box_real_get_login_name (LoginMask* base)
{
	const gchar* result;
	LoginBox* self;
	LoginOption* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	CredentialsArea* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 41 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 42 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->_user;
#line 42 "../src/Widgets/LoginBox.vala"
	_tmp1_ = login_option_get_provides_login_name (_tmp0_);
#line 42 "../src/Widgets/LoginBox.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/Widgets/LoginBox.vala"
	if (_tmp2_) {
#line 493 "LoginBox.c"
		LoginOption* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 43 "../src/Widgets/LoginBox.vala"
		_tmp3_ = self->priv->_user;
#line 43 "../src/Widgets/LoginBox.vala"
		_tmp4_ = login_option_get_name (_tmp3_);
#line 43 "../src/Widgets/LoginBox.vala"
		_tmp5_ = _tmp4_;
#line 43 "../src/Widgets/LoginBox.vala"
		result = _tmp5_;
#line 43 "../src/Widgets/LoginBox.vala"
		return result;
#line 507 "LoginBox.c"
	}
#line 45 "../src/Widgets/LoginBox.vala"
	_tmp6_ = self->priv->credentials_area;
#line 45 "../src/Widgets/LoginBox.vala"
	_tmp7_ = credentials_area_get_login_name (_tmp6_);
#line 45 "../src/Widgets/LoginBox.vala"
	_tmp8_ = _tmp7_;
#line 45 "../src/Widgets/LoginBox.vala"
	result = _tmp8_;
#line 45 "../src/Widgets/LoginBox.vala"
	return result;
#line 519 "LoginBox.c"
}

static const gchar*
login_box_real_get_login_session (LoginMask* base)
{
	const gchar* result;
	LoginBox* self;
	CredentialsArea* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 50 "../src/Widgets/LoginBox.vala"
	self = (LoginBox*) base;
#line 51 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 51 "../src/Widgets/LoginBox.vala"
	_tmp1_ = credentials_area_get_current_session (_tmp0_);
#line 51 "../src/Widgets/LoginBox.vala"
	_tmp2_ = _tmp1_;
#line 51 "../src/Widgets/LoginBox.vala"
	result = _tmp2_;
#line 51 "../src/Widgets/LoginBox.vala"
	return result;
#line 542 "LoginBox.c"
}

LoginOption*
login_box_get_user (LoginBox* self)
{
	LoginOption* result;
	LoginOption* _tmp0_;
#line 55 "../src/Widgets/LoginBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->_user;
#line 55 "../src/Widgets/LoginBox.vala"
	result = _tmp0_;
#line 55 "../src/Widgets/LoginBox.vala"
	return result;
#line 558 "LoginBox.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/Widgets/LoginBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 566 "LoginBox.c"
}

static void
login_box_set_user (LoginBox* self,
                    LoginOption* value)
{
#line 55 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Widgets/LoginBox.vala"
	if (login_box_get_user (self) != value) {
#line 577 "LoginBox.c"
		LoginOption* _tmp0_;
#line 55 "../src/Widgets/LoginBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 55 "../src/Widgets/LoginBox.vala"
		_g_object_unref0 (self->priv->_user);
#line 55 "../src/Widgets/LoginBox.vala"
		self->priv->_user = _tmp0_;
#line 55 "../src/Widgets/LoginBox.vala"
		g_object_notify_by_pspec ((GObject *) self, login_box_properties[LOGIN_BOX_USER_PROPERTY]);
#line 587 "LoginBox.c"
	}
}

static gboolean
_login_box___lambda17_ (LoginBox* self)
{
	gboolean result = FALSE;
#line 76 "../src/Widgets/LoginBox.vala"
	g_signal_emit (self, login_box_signals[LOGIN_BOX_CLICKED_SIGNAL], 0);
#line 77 "../src/Widgets/LoginBox.vala"
	result = FALSE;
#line 77 "../src/Widgets/LoginBox.vala"
	return result;
#line 601 "LoginBox.c"
}

static gboolean
__login_box___lambda17__clutter_actor_button_press_event (ClutterActor* _sender,
                                                          ClutterButtonEvent* event,
                                                          gpointer self)
{
	gboolean result;
	result = _login_box___lambda17_ ((LoginBox*) self);
#line 75 "../src/Widgets/LoginBox.vala"
	return result;
#line 613 "LoginBox.c"
}

static gboolean
_login_box___lambda18_ (LoginBox* self)
{
	gboolean result = FALSE;
#line 81 "../src/Widgets/LoginBox.vala"
	g_signal_emit (self, login_box_signals[LOGIN_BOX_CLICKED_SIGNAL], 0);
#line 82 "../src/Widgets/LoginBox.vala"
	result = FALSE;
#line 82 "../src/Widgets/LoginBox.vala"
	return result;
#line 626 "LoginBox.c"
}

static gboolean
__login_box___lambda18__gtk_widget_button_press_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self)
{
	gboolean result;
	result = _login_box___lambda18_ ((LoginBox*) self);
#line 80 "../src/Widgets/LoginBox.vala"
	return result;
#line 638 "LoginBox.c"
}

static void
_login_box___lambda19_ (LoginBox* self,
                        const gchar* answer)
{
	CredentialsArea* _tmp0_;
	LoginGateway* _tmp1_;
	LoginGateway* _tmp2_;
#line 109 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (answer != NULL);
#line 110 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->credentials_area;
#line 110 "../src/Widgets/LoginBox.vala"
	credentials_area_remove_credentials (_tmp0_);
#line 111 "../src/Widgets/LoginBox.vala"
	_tmp1_ = pantheon_greeter_get_login_gateway ();
#line 111 "../src/Widgets/LoginBox.vala"
	_tmp2_ = _tmp1_;
#line 111 "../src/Widgets/LoginBox.vala"
	login_gateway_respond (_tmp2_, answer);
#line 660 "LoginBox.c"
}

static void
__login_box___lambda19__credentials_area_replied (CredentialsArea* _sender,
                                                  const gchar* text,
                                                  gpointer self)
{
#line 109 "../src/Widgets/LoginBox.vala"
	_login_box___lambda19_ ((LoginBox*) self, text);
#line 670 "LoginBox.c"
}

static void
_login_box___lambda20_ (LoginBox* self,
                        const gchar* name)
{
#line 114 "../src/Widgets/LoginBox.vala"
	g_return_if_fail (name != NULL);
#line 115 "../src/Widgets/LoginBox.vala"
	login_box_start_login (self);
#line 681 "LoginBox.c"
}

static void
__login_box___lambda20__credentials_area_entered_login_name (CredentialsArea* _sender,
                                                             const gchar* name,
                                                             gpointer self)
{
#line 114 "../src/Widgets/LoginBox.vala"
	_login_box___lambda20_ ((LoginBox*) self, name);
#line 691 "LoginBox.c"
}

static GObject *
login_box_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	LoginBox * self;
	LoginOption* _tmp0_;
	CredentialsArea* _tmp1_;
	gchar* path = NULL;
	LoginOption* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GraniteWidgetsAvatar* avatar = NULL;
	const gchar* _tmp6_;
	GraniteWidgetsAvatar* _tmp10_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GraniteWidgetsAvatar* _tmp14_;
	GtkGrid* _tmp15_;
	CredentialsArea* _tmp16_;
	GtkGrid* _tmp17_;
	GtkClutterActor* credentials_area_actor = NULL;
	GtkClutterActor* _tmp18_;
	GtkClutterActor* _tmp19_;
	GtkClutterActor* _tmp20_;
	GtkWidget* _tmp21_;
	GtkGrid* _tmp22_;
	GtkClutterActor* _tmp23_;
	LoginOption* _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	CredentialsArea* _tmp35_;
	CredentialsArea* _tmp36_;
#line 61 "../src/Widgets/LoginBox.vala"
	parent_class = G_OBJECT_CLASS (login_box_parent_class);
#line 61 "../src/Widgets/LoginBox.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "../src/Widgets/LoginBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOGIN_BOX, LoginBox);
#line 62 "../src/Widgets/LoginBox.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 64 "../src/Widgets/LoginBox.vala"
	_tmp0_ = self->priv->_user;
#line 64 "../src/Widgets/LoginBox.vala"
	_tmp1_ = credentials_area_new (self, _tmp0_);
#line 64 "../src/Widgets/LoginBox.vala"
	g_object_ref_sink (_tmp1_);
#line 64 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (self->priv->credentials_area);
#line 64 "../src/Widgets/LoginBox.vala"
	self->priv->credentials_area = _tmp1_;
#line 66 "../src/Widgets/LoginBox.vala"
	_tmp2_ = self->priv->_user;
#line 66 "../src/Widgets/LoginBox.vala"
	_tmp3_ = login_option_get_avatar_path (_tmp2_);
#line 66 "../src/Widgets/LoginBox.vala"
	_tmp4_ = _tmp3_;
#line 66 "../src/Widgets/LoginBox.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 66 "../src/Widgets/LoginBox.vala"
	path = _tmp5_;
#line 69 "../src/Widgets/LoginBox.vala"
	_tmp6_ = path;
#line 69 "../src/Widgets/LoginBox.vala"
	if (_tmp6_ != NULL) {
#line 764 "LoginBox.c"
		const gchar* _tmp7_;
		GraniteWidgetsAvatar* _tmp8_;
#line 70 "../src/Widgets/LoginBox.vala"
		_tmp7_ = path;
#line 70 "../src/Widgets/LoginBox.vala"
		_tmp8_ = granite_widgets_avatar_new_from_file (_tmp7_, 96);
#line 70 "../src/Widgets/LoginBox.vala"
		g_object_ref_sink (_tmp8_);
#line 70 "../src/Widgets/LoginBox.vala"
		_g_object_unref0 (avatar);
#line 70 "../src/Widgets/LoginBox.vala"
		avatar = _tmp8_;
#line 777 "LoginBox.c"
	} else {
		GraniteWidgetsAvatar* _tmp9_;
#line 72 "../src/Widgets/LoginBox.vala"
		_tmp9_ = granite_widgets_avatar_new_with_default_icon (96);
#line 72 "../src/Widgets/LoginBox.vala"
		g_object_ref_sink (_tmp9_);
#line 72 "../src/Widgets/LoginBox.vala"
		_g_object_unref0 (avatar);
#line 72 "../src/Widgets/LoginBox.vala"
		avatar = _tmp9_;
#line 788 "LoginBox.c"
	}
#line 75 "../src/Widgets/LoginBox.vala"
	g_signal_connect_object ((ClutterActor*) self, "button-press-event", (GCallback) __login_box___lambda17__clutter_actor_button_press_event, self, 0);
#line 80 "../src/Widgets/LoginBox.vala"
	_tmp10_ = avatar;
#line 80 "../src/Widgets/LoginBox.vala"
	g_signal_connect_object ((GtkWidget*) _tmp10_, "button-press-event", (GCallback) __login_box___lambda18__gtk_widget_button_press_event, self, 0);
#line 85 "../src/Widgets/LoginBox.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 85 "../src/Widgets/LoginBox.vala"
	g_object_ref_sink (_tmp11_);
#line 85 "../src/Widgets/LoginBox.vala"
	grid = _tmp11_;
#line 86 "../src/Widgets/LoginBox.vala"
	_tmp12_ = grid;
#line 86 "../src/Widgets/LoginBox.vala"
	gtk_grid_set_column_spacing (_tmp12_, 12);
#line 87 "../src/Widgets/LoginBox.vala"
	_tmp13_ = grid;
#line 87 "../src/Widgets/LoginBox.vala"
	_tmp14_ = avatar;
#line 87 "../src/Widgets/LoginBox.vala"
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 88 "../src/Widgets/LoginBox.vala"
	_tmp15_ = grid;
#line 88 "../src/Widgets/LoginBox.vala"
	_tmp16_ = self->priv->credentials_area;
#line 88 "../src/Widgets/LoginBox.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 89 "../src/Widgets/LoginBox.vala"
	_tmp17_ = grid;
#line 89 "../src/Widgets/LoginBox.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp17_);
#line 91 "../src/Widgets/LoginBox.vala"
	_tmp18_ = (GtkClutterActor*) gtk_clutter_actor_new ();
#line 91 "../src/Widgets/LoginBox.vala"
	g_object_ref_sink (_tmp18_);
#line 91 "../src/Widgets/LoginBox.vala"
	credentials_area_actor = _tmp18_;
#line 92 "../src/Widgets/LoginBox.vala"
	_tmp19_ = credentials_area_actor;
#line 92 "../src/Widgets/LoginBox.vala"
	clutter_actor_set_height ((ClutterActor*) _tmp19_, (gfloat) 188);
#line 94 "../src/Widgets/LoginBox.vala"
	_tmp20_ = credentials_area_actor;
#line 94 "../src/Widgets/LoginBox.vala"
	_tmp21_ = gtk_clutter_actor_get_widget (_tmp20_);
#line 94 "../src/Widgets/LoginBox.vala"
	_tmp22_ = grid;
#line 94 "../src/Widgets/LoginBox.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp22_);
#line 96 "../src/Widgets/LoginBox.vala"
	_tmp23_ = credentials_area_actor;
#line 96 "../src/Widgets/LoginBox.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp23_);
#line 98 "../src/Widgets/LoginBox.vala"
	_tmp24_ = self->priv->_user;
#line 98 "../src/Widgets/LoginBox.vala"
	_tmp25_ = login_option_get_logged_in (_tmp24_);
#line 98 "../src/Widgets/LoginBox.vala"
	_tmp26_ = _tmp25_;
#line 98 "../src/Widgets/LoginBox.vala"
	if (_tmp26_) {
#line 852 "LoginBox.c"
		GtkImage* logged_in = NULL;
		GtkImage* _tmp27_;
		GtkClutterActor* logged_in_actor = NULL;
		GtkClutterActor* _tmp28_;
		GtkClutterActor* _tmp29_;
		GtkClutterActor* _tmp30_;
		GtkClutterActor* _tmp31_;
		GtkWidget* _tmp32_;
		GtkImage* _tmp33_;
		GtkClutterActor* _tmp34_;
#line 99 "../src/Widgets/LoginBox.vala"
		_tmp27_ = (GtkImage*) gtk_image_new_from_icon_name ("selection-checked", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 99 "../src/Widgets/LoginBox.vala"
		g_object_ref_sink (_tmp27_);
#line 99 "../src/Widgets/LoginBox.vala"
		logged_in = _tmp27_;
#line 101 "../src/Widgets/LoginBox.vala"
		_tmp28_ = (GtkClutterActor*) gtk_clutter_actor_new ();
#line 101 "../src/Widgets/LoginBox.vala"
		g_object_ref_sink (_tmp28_);
#line 101 "../src/Widgets/LoginBox.vala"
		logged_in_actor = _tmp28_;
#line 102 "../src/Widgets/LoginBox.vala"
		_tmp29_ = logged_in_actor;
#line 102 "../src/Widgets/LoginBox.vala"
		_tmp30_ = logged_in_actor;
#line 102 "../src/Widgets/LoginBox.vala"
		clutter_actor_set_y ((ClutterActor*) _tmp30_, (gfloat) 75);
#line 102 "../src/Widgets/LoginBox.vala"
		clutter_actor_set_x ((ClutterActor*) _tmp29_, (gfloat) 75);
#line 104 "../src/Widgets/LoginBox.vala"
		_tmp31_ = logged_in_actor;
#line 104 "../src/Widgets/LoginBox.vala"
		_tmp32_ = gtk_clutter_actor_get_widget (_tmp31_);
#line 104 "../src/Widgets/LoginBox.vala"
		_tmp33_ = logged_in;
#line 104 "../src/Widgets/LoginBox.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp33_);
#line 106 "../src/Widgets/LoginBox.vala"
		_tmp34_ = logged_in_actor;
#line 106 "../src/Widgets/LoginBox.vala"
		clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp34_);
#line 98 "../src/Widgets/LoginBox.vala"
		_g_object_unref0 (logged_in_actor);
#line 98 "../src/Widgets/LoginBox.vala"
		_g_object_unref0 (logged_in);
#line 899 "LoginBox.c"
	}
#line 109 "../src/Widgets/LoginBox.vala"
	_tmp35_ = self->priv->credentials_area;
#line 109 "../src/Widgets/LoginBox.vala"
	g_signal_connect_object (_tmp35_, "replied", (GCallback) __login_box___lambda19__credentials_area_replied, self, 0);
#line 114 "../src/Widgets/LoginBox.vala"
	_tmp36_ = self->priv->credentials_area;
#line 114 "../src/Widgets/LoginBox.vala"
	g_signal_connect_object (_tmp36_, "entered-login-name", (GCallback) __login_box___lambda20__credentials_area_entered_login_name, self, 0);
#line 61 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (credentials_area_actor);
#line 61 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (grid);
#line 61 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (avatar);
#line 61 "../src/Widgets/LoginBox.vala"
	_g_free0 (path);
#line 61 "../src/Widgets/LoginBox.vala"
	return obj;
#line 919 "LoginBox.c"
}

static void
login_box_class_init (LoginBoxClass * klass,
                      gpointer klass_data)
{
#line 22 "../src/Widgets/LoginBox.vala"
	login_box_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/LoginBox.vala"
	g_type_class_adjust_private_offset (klass, &LoginBox_private_offset);
#line 22 "../src/Widgets/LoginBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_login_box_get_property;
#line 22 "../src/Widgets/LoginBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_login_box_set_property;
#line 22 "../src/Widgets/LoginBox.vala"
	G_OBJECT_CLASS (klass)->constructor = login_box_constructor;
#line 22 "../src/Widgets/LoginBox.vala"
	G_OBJECT_CLASS (klass)->finalize = login_box_finalize;
#line 22 "../src/Widgets/LoginBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_BOX_SELECTED_PROPERTY, login_box_properties[LOGIN_BOX_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/LoginBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_BOX_LOGIN_NAME_PROPERTY, login_box_properties[LOGIN_BOX_LOGIN_NAME_PROPERTY] = g_param_spec_string ("login-name", "login-name", "login-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/LoginBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_BOX_LOGIN_SESSION_PROPERTY, login_box_properties[LOGIN_BOX_LOGIN_SESSION_PROPERTY] = g_param_spec_string ("login-session", "login-session", "login-session", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/LoginBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LOGIN_BOX_USER_PROPERTY, login_box_properties[LOGIN_BOX_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", TYPE_LOGIN_OPTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/LoginBox.vala"
	login_box_signals[LOGIN_BOX_CLICKED_SIGNAL] = g_signal_new ("clicked", TYPE_LOGIN_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 948 "LoginBox.c"
}

static void
login_box_login_mask_interface_init (LoginMaskIface * iface,
                                     gpointer iface_data)
{
#line 22 "../src/Widgets/LoginBox.vala"
	login_box_login_mask_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../src/Widgets/LoginBox.vala"
	iface->show_prompt = (void (*) (LoginMask*, PromptType, PromptText, const gchar*)) login_box_real_show_prompt;
#line 22 "../src/Widgets/LoginBox.vala"
	iface->show_message = (void (*) (LoginMask*, LightDMMessageType, MessageText, const gchar*)) login_box_real_show_message;
#line 22 "../src/Widgets/LoginBox.vala"
	iface->not_authenticated = (void (*) (LoginMask*)) login_box_real_not_authenticated;
#line 22 "../src/Widgets/LoginBox.vala"
	iface->login_aborted = (void (*) (LoginMask*)) login_box_real_login_aborted;
#line 22 "../src/Widgets/LoginBox.vala"
	iface->get_login_name = login_box_real_get_login_name;
#line 22 "../src/Widgets/LoginBox.vala"
	iface->get_login_session = login_box_real_get_login_session;
#line 969 "LoginBox.c"
}

static void
login_box_instance_init (LoginBox * self,
                         gpointer klass)
{
#line 22 "../src/Widgets/LoginBox.vala"
	self->priv = login_box_get_instance_private (self);
#line 25 "../src/Widgets/LoginBox.vala"
	self->priv->_selected = FALSE;
#line 980 "LoginBox.c"
}

static void
login_box_finalize (GObject * obj)
{
	LoginBox * self;
#line 22 "../src/Widgets/LoginBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOGIN_BOX, LoginBox);
#line 23 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (self->priv->credentials_area);
#line 55 "../src/Widgets/LoginBox.vala"
	_g_object_unref0 (self->priv->_user);
#line 22 "../src/Widgets/LoginBox.vala"
	G_OBJECT_CLASS (login_box_parent_class)->finalize (obj);
#line 995 "LoginBox.c"
}

GType
login_box_get_type (void)
{
	static volatile gsize login_box_type_id__volatile = 0;
	if (g_once_init_enter (&login_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LoginBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) login_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LoginBox), 0, (GInstanceInitFunc) login_box_instance_init, NULL };
		static const GInterfaceInfo login_mask_info = { (GInterfaceInitFunc) login_box_login_mask_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType login_box_type_id;
		login_box_type_id = g_type_register_static (gtk_clutter_actor_get_type (), "LoginBox", &g_define_type_info, 0);
		g_type_add_interface_static (login_box_type_id, TYPE_LOGIN_MASK, &login_mask_info);
		LoginBox_private_offset = g_type_add_instance_private (login_box_type_id, sizeof (LoginBoxPrivate));
		g_once_init_leave (&login_box_type_id__volatile, login_box_type_id);
	}
	return login_box_type_id__volatile;
}

static void
_vala_login_box_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	LoginBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_BOX, LoginBox);
#line 22 "../src/Widgets/LoginBox.vala"
	switch (property_id) {
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_SELECTED_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		g_value_set_boolean (value, login_box_get_selected (self));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_LOGIN_NAME_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		g_value_set_string (value, login_mask_get_login_name ((LoginMask*) self));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_LOGIN_SESSION_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		g_value_set_string (value, login_mask_get_login_session ((LoginMask*) self));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_USER_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		g_value_set_object (value, login_box_get_user (self));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 1048 "LoginBox.c"
		default:
#line 22 "../src/Widgets/LoginBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 1054 "LoginBox.c"
	}
}

static void
_vala_login_box_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	LoginBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LOGIN_BOX, LoginBox);
#line 22 "../src/Widgets/LoginBox.vala"
	switch (property_id) {
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_SELECTED_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		login_box_set_selected (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 22 "../src/Widgets/LoginBox.vala"
		case LOGIN_BOX_USER_PROPERTY:
#line 22 "../src/Widgets/LoginBox.vala"
		login_box_set_user (self, g_value_get_object (value));
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 1080 "LoginBox.c"
		default:
#line 22 "../src/Widgets/LoginBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/LoginBox.vala"
		break;
#line 1086 "LoginBox.c"
	}
}

