/* TimeLabel.c generated by valac 0.43.6, the Vala compiler
 * generated from TimeLabel.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://github.com/elementary/greeter)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define TYPE_TIME_LABEL (time_label_get_type ())
#define TIME_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIME_LABEL, TimeLabel))
#define TIME_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIME_LABEL, TimeLabelClass))
#define IS_TIME_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIME_LABEL))
#define IS_TIME_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIME_LABEL))
#define TIME_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIME_LABEL, TimeLabelClass))

typedef struct _TimeLabel TimeLabel;
typedef struct _TimeLabelClass TimeLabelClass;
typedef struct _TimeLabelPrivate TimeLabelPrivate;
enum  {
	TIME_LABEL_0_PROPERTY,
	TIME_LABEL_NUM_PROPERTIES
};
static GParamSpec* time_label_properties[TIME_LABEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _TimeLabel {
	GtkGrid parent_instance;
	TimeLabelPrivate * priv;
};

struct _TimeLabelClass {
	GtkGridClass parent_class;
};

struct _TimeLabelPrivate {
	GtkLabel* date_label;
	GtkLabel* time_label;
	GtkLabel* pm_label;
};

static gint TimeLabel_private_offset;
static gpointer time_label_parent_class = NULL;

GType time_label_get_type (void) G_GNUC_CONST;
TimeLabel* time_label_new (void);
TimeLabel* time_label_construct (GType object_type);
static gboolean time_label_update_time (TimeLabel* self);
static gboolean _time_label_update_time_gsource_func (gpointer self);
static GObject * time_label_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
static void time_label_finalize (GObject * obj);

static inline gpointer
time_label_get_instance_private (TimeLabel* self)
{
	return G_STRUCT_MEMBER_P (self, TimeLabel_private_offset);
}

static gboolean
_time_label_update_time_gsource_func (gpointer self)
{
	gboolean result;
	result = time_label_update_time ((TimeLabel*) self);
#line 28 "../src/Widgets/TimeLabel.vala"
	return result;
#line 93 "TimeLabel.c"
}

TimeLabel*
time_label_construct (GType object_type)
{
	TimeLabel * self = NULL;
#line 26 "../src/Widgets/TimeLabel.vala"
	self = (TimeLabel*) g_object_new (object_type, NULL);
#line 27 "../src/Widgets/TimeLabel.vala"
	time_label_update_time (self);
#line 28 "../src/Widgets/TimeLabel.vala"
	clutter_threads_add_timeout ((guint) 5000, _time_label_update_time_gsource_func, self);
#line 26 "../src/Widgets/TimeLabel.vala"
	return self;
#line 108 "TimeLabel.c"
}

TimeLabel*
time_label_new (void)
{
#line 26 "../src/Widgets/TimeLabel.vala"
	return time_label_construct (TYPE_TIME_LABEL);
#line 116 "TimeLabel.c"
}

static gboolean
time_label_update_time (TimeLabel* self)
{
	gboolean result = FALSE;
	GDateTime* date = NULL;
	GDateTime* _tmp0_;
	gchar* day_format = NULL;
	gchar* _tmp1_;
	gchar* time_format = NULL;
	gchar* _tmp2_;
	gchar* meridiem_format = NULL;
	gchar* _tmp3_;
	GtkLabel* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GtkLabel* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
#line 49 "../src/Widgets/TimeLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/Widgets/TimeLabel.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 50 "../src/Widgets/TimeLabel.vala"
	date = _tmp0_;
#line 53 "../src/Widgets/TimeLabel.vala"
	_tmp1_ = g_strdup (_ ("%A, %B %e"));
#line 53 "../src/Widgets/TimeLabel.vala"
	day_format = _tmp1_;
#line 55 "../src/Widgets/TimeLabel.vala"
	_tmp2_ = g_strdup (_ ("%l:%M"));
#line 55 "../src/Widgets/TimeLabel.vala"
	time_format = _tmp2_;
#line 57 "../src/Widgets/TimeLabel.vala"
	_tmp3_ = g_strdup (_ (" %p"));
#line 57 "../src/Widgets/TimeLabel.vala"
	meridiem_format = _tmp3_;
#line 59 "../src/Widgets/TimeLabel.vala"
	_tmp4_ = self->priv->date_label;
#line 59 "../src/Widgets/TimeLabel.vala"
	_tmp5_ = g_date_time_format (date, day_format);
#line 59 "../src/Widgets/TimeLabel.vala"
	_tmp6_ = _tmp5_;
#line 59 "../src/Widgets/TimeLabel.vala"
	gtk_label_set_label (_tmp4_, _tmp6_);
#line 59 "../src/Widgets/TimeLabel.vala"
	_g_free0 (_tmp6_);
#line 60 "../src/Widgets/TimeLabel.vala"
	_tmp7_ = self->priv->time_label;
#line 60 "../src/Widgets/TimeLabel.vala"
	_tmp8_ = g_date_time_format (date, time_format);
#line 60 "../src/Widgets/TimeLabel.vala"
	_tmp9_ = _tmp8_;
#line 60 "../src/Widgets/TimeLabel.vala"
	gtk_label_set_label (_tmp7_, _tmp9_);
#line 60 "../src/Widgets/TimeLabel.vala"
	_g_free0 (_tmp9_);
#line 61 "../src/Widgets/TimeLabel.vala"
	_tmp10_ = self->priv->pm_label;
#line 61 "../src/Widgets/TimeLabel.vala"
	_tmp11_ = g_date_time_format (date, meridiem_format);
#line 61 "../src/Widgets/TimeLabel.vala"
	_tmp12_ = _tmp11_;
#line 61 "../src/Widgets/TimeLabel.vala"
	gtk_label_set_label (_tmp10_, _tmp12_);
#line 61 "../src/Widgets/TimeLabel.vala"
	_g_free0 (_tmp12_);
#line 62 "../src/Widgets/TimeLabel.vala"
	result = TRUE;
#line 62 "../src/Widgets/TimeLabel.vala"
	_g_free0 (meridiem_format);
#line 62 "../src/Widgets/TimeLabel.vala"
	_g_free0 (time_format);
#line 62 "../src/Widgets/TimeLabel.vala"
	_g_free0 (day_format);
#line 62 "../src/Widgets/TimeLabel.vala"
	_g_date_time_unref0 (date);
#line 62 "../src/Widgets/TimeLabel.vala"
	return result;
#line 200 "TimeLabel.c"
}

static GObject *
time_label_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TimeLabel * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkStyleContext* _tmp9_;
	GtkLabel* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
#line 31 "../src/Widgets/TimeLabel.vala"
	parent_class = G_OBJECT_CLASS (time_label_parent_class);
#line 31 "../src/Widgets/TimeLabel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Widgets/TimeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIME_LABEL, TimeLabel);
#line 32 "../src/Widgets/TimeLabel.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("");
#line 32 "../src/Widgets/TimeLabel.vala"
	g_object_ref_sink (_tmp0_);
#line 32 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->date_label);
#line 32 "../src/Widgets/TimeLabel.vala"
	self->priv->date_label = _tmp0_;
#line 33 "../src/Widgets/TimeLabel.vala"
	_tmp1_ = self->priv->date_label;
#line 33 "../src/Widgets/TimeLabel.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 33 "../src/Widgets/TimeLabel.vala"
	gtk_style_context_add_class (_tmp2_, "h2");
#line 34 "../src/Widgets/TimeLabel.vala"
	_tmp3_ = self->priv->date_label;
#line 34 "../src/Widgets/TimeLabel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 36 "../src/Widgets/TimeLabel.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 36 "../src/Widgets/TimeLabel.vala"
	g_object_ref_sink (_tmp4_);
#line 36 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->time_label);
#line 36 "../src/Widgets/TimeLabel.vala"
	self->priv->time_label = _tmp4_;
#line 37 "../src/Widgets/TimeLabel.vala"
	_tmp5_ = self->priv->time_label;
#line 37 "../src/Widgets/TimeLabel.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 37 "../src/Widgets/TimeLabel.vala"
	gtk_style_context_add_class (_tmp6_, "time");
#line 39 "../src/Widgets/TimeLabel.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new ("");
#line 39 "../src/Widgets/TimeLabel.vala"
	g_object_ref_sink (_tmp7_);
#line 39 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->pm_label);
#line 39 "../src/Widgets/TimeLabel.vala"
	self->priv->pm_label = _tmp7_;
#line 40 "../src/Widgets/TimeLabel.vala"
	_tmp8_ = self->priv->pm_label;
#line 40 "../src/Widgets/TimeLabel.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 40 "../src/Widgets/TimeLabel.vala"
	gtk_style_context_add_class (_tmp9_, "time");
#line 41 "../src/Widgets/TimeLabel.vala"
	_tmp10_ = self->priv->pm_label;
#line 41 "../src/Widgets/TimeLabel.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 41 "../src/Widgets/TimeLabel.vala"
	gtk_style_context_add_class (_tmp11_, "pm");
#line 43 "../src/Widgets/TimeLabel.vala"
	_tmp12_ = self->priv->date_label;
#line 43 "../src/Widgets/TimeLabel.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp12_, 0, 0, 2, 1);
#line 44 "../src/Widgets/TimeLabel.vala"
	_tmp13_ = self->priv->time_label;
#line 44 "../src/Widgets/TimeLabel.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp13_, 0, 1, 1, 1);
#line 45 "../src/Widgets/TimeLabel.vala"
	_tmp14_ = self->priv->pm_label;
#line 45 "../src/Widgets/TimeLabel.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, 1, 1, 1, 1);
#line 46 "../src/Widgets/TimeLabel.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 31 "../src/Widgets/TimeLabel.vala"
	return obj;
#line 300 "TimeLabel.c"
}

static void
time_label_class_init (TimeLabelClass * klass,
                       gpointer klass_data)
{
#line 21 "../src/Widgets/TimeLabel.vala"
	time_label_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/TimeLabel.vala"
	g_type_class_adjust_private_offset (klass, &TimeLabel_private_offset);
#line 21 "../src/Widgets/TimeLabel.vala"
	G_OBJECT_CLASS (klass)->constructor = time_label_constructor;
#line 21 "../src/Widgets/TimeLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = time_label_finalize;
#line 315 "TimeLabel.c"
}

static void
time_label_instance_init (TimeLabel * self,
                          gpointer klass)
{
#line 21 "../src/Widgets/TimeLabel.vala"
	self->priv = time_label_get_instance_private (self);
#line 324 "TimeLabel.c"
}

static void
time_label_finalize (GObject * obj)
{
	TimeLabel * self;
#line 21 "../src/Widgets/TimeLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIME_LABEL, TimeLabel);
#line 22 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->date_label);
#line 23 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->time_label);
#line 24 "../src/Widgets/TimeLabel.vala"
	_g_object_unref0 (self->priv->pm_label);
#line 21 "../src/Widgets/TimeLabel.vala"
	G_OBJECT_CLASS (time_label_parent_class)->finalize (obj);
#line 341 "TimeLabel.c"
}

GType
time_label_get_type (void)
{
	static volatile gsize time_label_type_id__volatile = 0;
	if (g_once_init_enter (&time_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TimeLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) time_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimeLabel), 0, (GInstanceInitFunc) time_label_instance_init, NULL };
		GType time_label_type_id;
		time_label_type_id = g_type_register_static (gtk_grid_get_type (), "TimeLabel", &g_define_type_info, 0);
		TimeLabel_private_offset = g_type_add_instance_private (time_label_type_id, sizeof (TimeLabelPrivate));
		g_once_init_leave (&time_label_type_id__volatile, time_label_type_id);
	}
	return time_label_type_id__volatile;
}

